/*
 * AllocFloatSequence.c
 *
 *  function allocates a float image structure on the heap
 *  to represent a 1D sequence.
 *
 *  jph 9/24/94
 *
 */
 
#ifndef ALLOCFLOATSEQUENCE_C
#define ALLOCFLOATSEQUENCE_C
#include <stdio.h>
#include "teager2D.h"
#include "Esa1D.h"

void AllocFloatSequence(X,size)
 
  pFloatImage  X;         /* the image to be allocated */
  int          size;      /* image row/col dimension (assumed square). */
 
{

  X->size = X->cols = size;
  X->rows = 1;
  X->square = 0;
  if ((X->Real = (float *)malloc(size * sizeof(float))) == NULL) {
    printf("\nAllocFloatSequence: free store exhausted\n");
    exit(-1);
  }
  if ((X->Imag = (float *)malloc(size * sizeof(float))) == NULL) {
    printf("\nAllocFloatSequence: free store exhausted\n");
    exit(-1);
  }
  if ((X->FFTReal = (float *)malloc(size * sizeof(float))) == NULL) {
    printf("\nAllocFloatSequence: free store exhausted\n");
    exit(-1);
  }
  if ((X->FFTImag = (float *)malloc(size * sizeof(float))) == NULL) {
    printf("\nAllocFloatSequence: free store exhausted\n");
    exit(-1);
  }
  return;
}
#endif
