/*
 * DoPostFilter1D
 *
 *   Use postfiltering to smooth the frequency estimates.
 *
 *  jph 4/12/96
 *
 */
#ifndef DOPOSTFILTER1D_C
#define DOPOSTFILTER1D_C
#include <stdio.h>
#include "teager2D.h"
#include "Esa1D.h"

void DoPostFilter1D(size,U,Usm,G,idx)
 
  int             size;           /* length of signal for reconstruction */
  float          *U;              /* raw frequency estimates */
  float          *Usm;            /* smoothed frequency estimates */
  filterbank     *G;              /* the filter bank */
  int             idx;            /* filterbank channel being smoothed */
{
 
  pFloatImage     g;              /* postfilter image */
  pFloatImage     Y;              /* image with Usm as real part */
  int             i;              /* counter */
 
 /*
  * Create PostFilter
  */
  g = MkPostFilt1D(G->filt[idx]->sigma,G->filt[idx]->kappa,size);
 
 /*
  * Allocate and initialize Y sequence
  */
  Y = (pFloatImage)malloc(sizeof(FloatImage));
  AllocFloatSequence(Y,size);
  free(Y->Real);
  Y->Real = Usm;
  for (i=0; i < size; i++) {
    Y->Real[i] = U[i];
    Y->Imag[i] = (float)0.0;
  }
  fft1d(Y->Real,Y->Imag,Y->FFTReal,Y->FFTImag,size,1);
 
 /*
  * Post Filter
  */
  REVFilter1D(Y,g);
 
 /*
  * Cleanup
  */
  g = KillFloat1D(g);
  Y->Real = NULL;
  Y = KillFloat1D(Y);
 
  return;
} /*----------------------------------------- DoPostFilter1D ----------------*/
#endif
