/*
 * REVFilter1D.c
 *
 *  Special Filtering routine for the case where one signal is real and
 *  even.
 *  Input signal A is convolved with input signal B, and the result of the
 *  convolution overwrites the values of signal A.  The two signals must
 *  be the same size.  The frequency domain values of the signals must be
 *  initialized.  The B signal must have all imaginary FFT coefficients zero.
 *
 *  jph 4/12/96
 */

#ifndef REVFILTER1D_C
#define REVFILTER1D_C
#include <stdio.h>
#include "teager2D.h"

void REVFilter1D(A,B)

  pFloatImage   A;  /* multiplicand image and output image */
  pFloatImage   B;  /* multiplier image */
{

  int         k;       /* counter for image pixels */

 /*
  * Compute the spectrum of the output
  */
  for (k=0; k < A->size; k++) {
    A->FFTReal[k] = A->FFTReal[k] * B->FFTReal[k];
    A->FFTImag[k] = A->FFTImag[k] * B->FFTReal[k];
  }

 /*
  * Compute the output signal by inverse fft
  */
  fft1d(A->Real,A->Imag,A->FFTReal,A->FFTImag,A->size,-1);

  return;
} 
#endif
