/*
 * fCMult.c
 *
 *   Function computes a float complex product.  Output (yReal, yImag) is
 *   set equal to the product of the inputs (aReal,aImag) * (bReal,bImag).
 *
 *  jph 9/13/93
 */

#ifndef FCMULT_C
#define FCMULT_C
#include <stdio.h>
#include "teager2D.h"

void fCMult(yReal,yImag,aReal,aImag,bReal,bImag)

  float *yReal;    /* pointer to real part of product */
  float *yImag;    /* pointer to imag part of product */
  float  aReal;    /* real part of multiplicand */
  float  aImag;    /* imag part of multiplicand */
  float  bReal;    /* real part of multiplier */
  float  bImag;    /* imag part of multiplier */
  
{
  *yReal = (aReal * bReal) - (aImag * bImag);
  *yImag = (aReal * bImag) + (aImag * bReal);
  return;
} 
#endif
