/*
 * fFiniteDif1D.c
 *
 *  Function computes the first finite difference of a float sequence.  The
 *  central difference is used, except at the end points where the appropriate
 *  assymetric difference is used.
 *
 *  It is assumed that the output array Dx has already been allocated.
 *
 *  jph 2/21/96
 *
 */

#ifndef FFINITEDIF1D_C
#define FFINITEDIF1D_C
#include "teager2D.h"
#include "Esa1D.h"
#include <stdio.h>

void fFiniteDif1D(x,size,Dx)

  float *x;           /* input sequence to be differenced */
  int    size;        /* length of input sequence */
  float *Dx;          /* first finite difference of x */

{
  int i;                        /* loop counter */

  Dx[0] = x[1] - x[0];
  Dx[size-1] = x[size] - x[size-1];
  for (i=1; i < size-1; i++) {
    Dx[i] = 0.5 * (x[i+1] - x[i-1]);
  }

  return;

}
#endif 
