/*
 * fShiftLeft1D.c
 *
 *  Function shifts a float sequence one sample to the left.  This turns
 *  x[n] into x[n+1].  The final point is handled by replication.
 *
 *  The output array is allocated on the heap.
 *
 *  jph 10/28/98
 *
 */

#ifndef FSHIFTLEFT1D_C
#define FSHIFTLEFT1D_C
#include "teager2D.h"
#include "Esa1D.h"
#include <stdio.h>

float *fShiftLeft1D(x,size)

  float      *x;      /* input float signal */
  int         size;   /* size of x array */

{
  int         i;         /* loop counter */
  float      *y;         /* output difference signal */

 /*
  * Allocate the output on the heap
  */
  if ((y = (float *)malloc(size*sizeof(float))) == NULL) {
    printf("\n\nfShiftLeft1D: free store exhausted.\n");
    exit(-1);
  }

 /*
  * Shift the signal left by one.
  */
  for (i=0; i < size-1; i++) {
    y[i] = x[i+1];
  }

 /*
  * Handle the final point by replication.
  */
  y[size-1] = y[size-2];

  return(y);

}
#endif
