/*
 * fTKEO1D.c
 *
 *  function invokes the discrete Teager-Kaiser energy operator on a float
 *  sequence.  Edge effects are handled by replication.
 *
 *  The output array is allocated on the heap.
 *
 *  jph 10/29/98
 *
 */

#ifndef FTKEO1D_C
#define FTKEO1D_C
#include "teager2D.h"
#include "Esa1D.h"
#include <stdio.h>

float *fTKEO1D(x,size)

  float      *x;      /* input float signal */
  int         size;   /* size of x array */

{
  int         i;         /* loop counter */
  float      *y;         /* output difference signal */

 /*
  * Allocate the output on the heap
  */
  if ((y = (float *)malloc(size*sizeof(float))) == NULL) {
    printf("\n\nfTKEO1D: free store exhausted.\n");
    exit(-1);
  }

 /*
  * TKEO on all but the two end samples.
  */
  for (i=1; i < size-1; i++) {
    y[i] = x[i] * x[i] - x[i+1] * x[i-1];
  }

 /*
  * Handle the end points by replication.
  */
  y[0] = y[1];
  y[size-1] = y[size-2];

  return(y);

}
#endif
