/*
 * DoPostFilter
 *
 *   Use postfiltering to smooth the frequency estimates.
 *
 *  jph 4/15/96
 *
 */
#ifndef DOPOSTFILTER_C
#define DOPOSTFILTER_C
#include <stdio.h>
#include "teager2D.h"

void DoPostFilter(g,size,U,Usm,G,idx)
 
  pFloatImage     g;              /* postfilter image */
  int             size;           /* length of signal for reconstruction */
  float          *U;              /* raw frequency estimates */
  float          *Usm;            /* smoothed frequency estimates */
  filterbank     *G;              /* the filter bank */
  int             idx;            /* filterbank channel being smoothed */
{
 
  pFloatImage     Y;              /* image with Usm as real part */
  int             i;              /* counter */
  int             n;              /* size * size */
 
 /*
  * Allocate and initialize Y sequence
  */
  n = size * size;
  Y = (pFloatImage)malloc(sizeof(FloatImage));
  AllocFloatImage(Y,size);
  free(Y->Real);
  Y->Real = Usm;
  for (i=0; i < n; i++) {
    Y->Real[i] = U[i];
    Y->Imag[i] = (float)0.0;
  }
  fft2d(Y->Real,Y->Imag,Y->FFTReal,Y->FFTImag,size,1);
 
 /*
  * Post Filter
  */
  REVFilter(Y,g);
 
 /*
  * Cleanup
  */
  Y->Real = NULL;
  Y = KillFloat(Y);
 
  return;
} /*----------------------------------------- DoPostFilter ------------------*/
#endif
