/*
 * Filter.c
 *
 *  Input Image A is convolved with input image B, and the result of the
 *  convolution overwrites the values of image A.  The two images must
 *  be the same size.  The frequency domain values of the images must be
 *  initialized.
 *
 *  jph 4/14/94
 */

#ifndef FILTER_C
#define FILTER_C
#include <stdio.h>
#include "teager2D.h"

void Filter(A,B)

  pFloatImage   A;  /* multiplicand image and output image */
  pFloatImage   B;  /* multiplier image */
{

  int         row;     /* counter for image rows */
  int         col;     /* counter for image cols */
  int         k;       /* counter for image pixels */
  float       Rtemp;   /* temporary real float */
  float       Itemp;   /* temporary imag float */

 /*
  * Compute the spectrum of the output
  */
  for (row=k=0; row < A->size; row++) {
    for (col=0; col < A->size; col++,k++) {
      fCMult(&Rtemp,         &Itemp,
              A->FFTReal[k],  A->FFTImag[k],
              B->FFTReal[k],  B->FFTImag[k]);
      A->FFTReal[k] = Rtemp;
      A->FFTImag[k] = Itemp;
    }
  }

 /*
  * Compute the image domain filtered response by inverse fft
  */
  fft2d(A->Real,A->Imag,A->FFTReal,A->FFTImag,A->size,-1);

  return;
} 
#endif
