/*
 * FindRadialDistance.c
 *
 *  Function inputs a 2D frequency (u,v) in cycles per pixel and a filter.  The
 *  radial distance from the input frequency to the filter center frequency is
 *  returned in cycles per pixel.  All parameters are of type double.
 *
 *  jph 9/10/93
 *
 */

#ifndef FINDRADIALDISTANCE_C
#define FINDRADIALDISTANCE_C
#include "teager2D.h"
#include <stdio.h>

double FindRadialDistance(f,u,v)

  FilterPtr   f;      /* filter whose center freq is to be used */
  double      u;      /* horizontal comp of freq in cycles per pixel */
  double      v;      /* vertical comp of freq in cycles per pixel */

{
  double   r;            /* radial magnitude of (u,v) in cycles per pixel */
  double   delta_u;      /* horizontal distance from u to f->u0 */
  double   delta_v;      /* vertical distance from v to f->v0 */

  delta_u = f->u0 - u;
  delta_v = f->v0 - v;
  return(dNorm(delta_u,delta_v));
}
#endif
