/*
 * FindRadialQual.c
 *
 *  Function returns the value 1 / ( 1 + FindRadialSigmas(f,u,v) ).
 *
 *  This quantity is used as a metric in deciding if a track should be
 *  updated using observations from the channel with channel filter f.
 *
 *  jph 10/8/96
 *
 */

#ifndef FINDRADIALQUAL_C
#define FINDRADIALQUAL_C
#include "teager2D.h"
#include <stdio.h>

double FindRadialQual(f,u,v)

  FilterPtr   f;      /* filter whose center freq is to be used */
  double      u;      /* horizontal comp of freq in cycles per pixel */
  double      v;      /* vertical comp of freq in cycles per pixel */

{

  double      Qual;   /* quality of match between channel and frequencies */

  Qual = (double)1.0 / ( (double)1.0 + FindRadialSigmas(f,u,v) );
  return(Qual);

}
#endif
