/*
 * FindRadialSigmas.c
 *
 *  Function inputs a 2D frequency (u,v) in cycles per pixel and a filter.  The
 *  radial distance from the input frequency to the filter center frequency is
 *  returned in units of inverse space constants.  
 *  All parameters are of type double.
 *
 *  jph 3/6/94
 *
 */

#ifndef FINDRADIALSIGMAS_C
#define FINDRADIALSIGMAS_C
#include "teager2D.h"
#include <stdio.h>

double FindRadialSigmas(f,u,v)

  FilterPtr   f;      /* filter whose center freq is to be used */
  double      u;      /* horizontal comp of freq in cycles per pixel */
  double      v;      /* vertical comp of freq in cycles per pixel */

{
  double   delta_u;      /* horizontal distance from u to f->u0 */
  double   delta_v;      /* vertical distance from v to f->v0 */

  delta_u = f->u0 - u;
  delta_v = f->v0 - v;
  return(dNorm(delta_u,delta_v)*f->sigma);
}
#endif
