/*
 * G_EvalMag.c
 *
 *  Function inputs a 2D frequency (u,v) in cycles per pixel and a filter.
 *  The magnitude response of the filter spectrum at the point (u,v) is 
 *  returned.
 *
 *  jph 9/10/93
 *
 */

#ifndef G_EVALMAG_C
#define G_EVALMAG_C
#include "teager2D.h"
#include <stdio.h>

float G_EvalMag(f,u,v)

  FilterPtr   f;      /* filter whose center freq is to be used */
  double      u;      /* horiz comp of freq where spectrum is to be evaluated */
  double      v;      /* vert  comp of freq where spectrum is to be evaluated */

{
 return((float)fabs(G_EvalReal(f,u,v)));
}
#endif
