/*
 * G_EvalReal.c
 *
 *  Function inputs a 2D frequency (u,v) in cycles per pixel and a filter.
 *  The Real value of the filter spectrum at the point (u,v) is returned.
 *
 *  jph 9/10/93
 *
 */

#ifndef G_EVALREAL_C
#define G_EVALREAL_C
#include "teager2D.h"
#include <stdio.h>

float G_EvalReal(f,u,v)

  FilterPtr   f;      /* filter whose center freq is to be used */
  double      u;      /* horiz comp of freq where spectrum is to be evaluated */
  double      v;      /* vert  comp of freq where spectrum is to be evaluated */

{

  double      a,b,c,d;
  float       e,g;


  a = (u - f->u0) * (u - f->u0);
  b = (v - f->v0) * (v - f->v0);
  c = f->GArgGaussCoef * (a + b);
  d = exp(c);
  e = (float)d;
  g = f->GMax * e;
  return(g);





/*
 return(f->GMax * (float)exp(f->GArgGaussCoef * 
             (pow((u - f->u0), (double)2.0) + pow((v - f->v0), (double)2.0))));
*/
}
#endif
