/*
 * PA.c
 *
 *   Function to print out an array in xdbx.
 *
 *   To make it available, do a degenerate call like 
 *     PA((void *)x,0,-1,'b'); somewhere in the program.
 *
 *   Parameters:
 *     
 *      x      base of array, cast to (void *)
 *      first  index of first element to print out
 *      last   index of last  element to print out
 *      d_type a char that tells the data type of the elements of x.
 *          'b'  for unsigned char (BYTE) in %d format
 *          'i'  for integer
 *          'f'  for float
 *          'd'  for double
 *          'c'  for char
 *
 *  jph 2 November 1993
 */

#ifndef PA_C
#define PA_C
#include <stdio.h>
#include "teager2D.h"

void PA(x,first,last,d_type)

  void *   x;
  int      first;
  int      last;
  char     d_type;

{

  int    i;

  printf("\n");
  switch(d_type) {
    case 'b':
    case 'i':
    case 'f':
    case 'd':
    case 'c':  break;

    default :  printf("PrintArray: unknown data type %c specified.",d_type);
               return;
  }
  for (i=first; i <= last ; i++) {
    switch(d_type) {
      case 'b':  printf("\n[%d]\t=\t%d",i,(BYTE) *( ((BYTE *)x) + i ));
                 break;
      case 'i':  printf("\n[%d]\t=\t%d",i,(int) *( ((int *)x) + i ));
                 break;
      case 'f':  printf("\n[%d]\t=\t%f",i,(float) *( ((float *)x) + i ));
                 break;
      case 'd':  printf("\n[%d]\t=\t%lf",i,(double) *( ((double *)x) + i ));
                 break;
      case 'c':  printf("\n[%d]\t=\t%c",i,(char) *( ((char *)x) + i ));
                 break;
    }
  }
  printf("\n");
  return;
}
#endif
