/*
 * REVFilter.c
 *
 *  Filtering routine for real & even filter function.  
 *  Input Image A is convolved with input image B, and the result of the
 *  convolution overwrites the values of image A.  The two images must
 *  be the same size.  The frequency domain values of the images must be
 *  initialized.  The filter (B) must have all imaginary FFT coefficients zero.
 *
 *  jph 8/20/94
 */

#ifndef REVFILTER_C
#define REVFILTER_C
#include <stdio.h>
#include "teager2D.h"

void REVFilter(A,B)

  pFloatImage   A;  /* multiplicand image and output image */
  pFloatImage   B;  /* multiplier image */
{

  int         row;     /* counter for image rows */
  int         col;     /* counter for image cols */
  int         k;       /* counter for image pixels */

 /*
  * Compute the spectrum of the output
  */
  for (row=k=0; row < A->size; row++) {
    for (col=0; col < A->size; col++,k++) {
      A->FFTReal[k] *= B->FFTReal[k];
      A->FFTImag[k] *= B->FFTReal[k];
    }
  }

 /*
  * Compute the image domain filtered response by inverse fft
  */
  fft2d(A->Real,A->Imag,A->FFTReal,A->FFTImag,A->size,-1);

  return;
} 
#endif
