/*
 * ZeroV0
 *
 *  Function inputs an image and it's spectrum and sets all
 *  frequency samples at the vertical Nyquist frequncy 
 *  to zero.
 *
 *  jph 20 Jan 1994.
 *
 */

#ifndef ZEROV0_C
#define ZEROV0_C
#include "teager2D.h"
#include <stdio.h>

void ZeroV0(xReal,xImag,XReal,XImag,size)

  float *xReal;       /* real part of signal */
  float *xImag;       /* imaginary part of signal */
  float *XReal;       /* real part of spectrum */
  float *XImag;       /* imaginary part of spectrum */
  int    size;        /* row/col dim of image */

{
  int i;                        /* loop counter */

 /*
  * Zero the frequency samples that have v = pi/2 rad/sample
  */
  for (i=0; i < size; i++) {
    XReal[i] = XImag[i] = (float) 0.0;
  }

 /*
  * Inverse fft 
  */
  fft2d(xReal,xImag,XReal,XImag,size,-1);

  return;

}
#endif 
