/*
 * bMakeFilterSpectrum.c
 *
 * Function creates a binary image suitable for display of the specified 
 * filter.  Since it is assumed to be a Gabor filter, the imaginary part is zero
 * and the magnitude equals the real part.
 * The output image are allocated on the heap.
 *
 *  jph 9/11/93
 *
 */

#ifndef BMAKEFILTERSPECTRUM_C
#define BMAKEFILTERSPECTRUM_C
#define BYTE unsigned char
#include "teager2D.h"
#include <stdio.h>

unsigned char *bMakeFilterSpectrum(f,size)

  FilterPtr   f;         /* filter to be evaluated */
  int         size;      /* row (col) dimension of the image */

{

  float      *R;         /* float real component array */
  BYTE       *Y;         /* output binary image */

  R = GMakeReal(f,size);
  Y = f_dbx(R,size,size);
  free(R);
  return(Y);

}
#endif
