/*
 * bShowBankSpectrum.c
 *
 * Function creates a binary image suitable for display of the specified 
 * filter Gabor filter bank.  The filterbank is an input to this routine.
 * The output image is allocated on the heap.
 *
 *  jph 9/13/93
 *
 */

#ifndef BSHOWBANKSPECTRUM_C
#define BSHOWBANKSPECTRUM_C
#define BYTE unsigned char
#include "teager2D.h"
#include <stdio.h>

unsigned char *bShowBankSpectrum(size,G)

  int         size;                /* row (col) dimension of the image */
  filterbank *G; 


{

  float      *M;         /* Composite Magnitude Image */
  float      *X;         /* magnitude spectrum of one filter in the bank */
  BYTE       *Y;         /* output binary image */
  int         i;         /* loop counter for filters in the bank */
  int         k;         /* loop counter for image coordinates */


  printf("\nDoing Filter 0...");
  M = GMakeMag(G->filt[0],size);
  for (i=1; i < G->TotNumFilters; i++) {
    printf("\nDoing Filter %d...",i);
    X = GMakeMag(G->filt[i],size);
    for (k=0; k < size*size; k++) {
      if (X[k] > M[k]) {
        M[k] = X[k];
      }
    }
    free(X);
  }
  Y = f_dbx(M,size,size);
  for (k=0; k < size*size; k++) {
    if (Y[k]) {
      M[k] = (float)log((double)Y[k]);
    }
    else {
      M[k] = pow((double)10.0,(double)-6.0);
    }
  }
  free(Y);
  Y = f_dbx(M,size,size);
  free(M);
  return(Y);

}
#endif
