/*
 * byte2float.c
 *
 *   function converts an unsigned char (byte) image to float.
 *
 *   the float image is allocated on the stack, the byte values
 *   are cast and copied into it, and a pointer to the new float
 *   image is returned.
 *
 *  jph 22 June 1992
 */

#ifndef BYTE2FLOAT_C
#define BYTE2FLOAT_C
#include <stdio.h>
#include "teager2D.h"

float* byte2float(x,row_dim,col_dim)

  unsigned char* x;         /* input image */
  int row_dim;    /* row dimension of x */
  int col_dim;    /* col dimension of x */
{

  float *y;          /* pointer to output image */
  int i;             /* loop counters */

 /*
  * detect zero dimension input
  */
  if ((row_dim==0) || (col_dim==0)) return NULL;

 /* 
  * allocate memory for y, return error if out of memory
  */
  y = (float *) malloc(row_dim * col_dim * sizeof(float));
  if (y == NULL) {
    printf("\nbyte2float.c : out of memory error !");
    return NULL;
  }

 /*
  * set y = x
  */
  for (i=0; i<row_dim * col_dim; i++) {
    y[i] = (float) x[i];
  }
  return y;
} 
#endif
