/*
 * chop.c
 *
 *   function chops exremals out of an unsigned char (byte) image.
 *
 *
 *  jph 15 June 1992
 */

#ifndef CHOP_C
#define CHOP_C
#include <stdio.h>
#include "teager2D.h"

void chop(x,row_dim,col_dim,min,max)

  unsigned char* x;     /* input image */
  int row_dim;    /* row dimension of x */
  int col_dim;    /* col dimension of x */
  unsigned char min,max; /* min and max values to be preserved in x */
{

  int i;             /* loop counters */

 /*
  * detect zero dimension input
  */
  if ((row_dim==0) || (col_dim==0)) return;


 /*
  *  Put x through a hard limiter
  */
  for (i=0; i<row_dim * col_dim; i++) {
    if (x[i] > max) x[i] = max;
    else if (x[i] < min) x[i] = min;
  }

  return;
} 
#endif
