/*
 * d2disk.c
 *
 *   function writes a double image to disk
 *
 *
 *  jph 22 June 1992
 */

#ifndef D2DISK_C
#define D2DISK_C
#include <stdio.h>
#include <fcntl.h>
#include "teager2D.h"

void d2disk(x,row_dim,col_dim,fn)

  double *x;            /* image to be written */
  int row_dim;          /* row dimension of x */
  int col_dim;          /* col dimension of x */
  char *fn;             /* filename */
{

  int fd;               /* file descriptor */
  int n_bytes;          /* number of bytes to read */

 /*
  * detect zero dimension input
  */
  if ((row_dim==0) || (col_dim==0)) return;

 /*
  * create and open the file
  */
  if ((fd = open(fn, O_WRONLY | O_CREAT | O_TRUNC, 0644))==-1) {
    printf("\nd2disk.c : could not open %s !",fn);
    return;
  }

 /*
  * write image data to the file
  */
  n_bytes = row_dim * col_dim * sizeof(double);
  if (write(fd,x,n_bytes) != n_bytes) {
    printf("\nd2disk.c : complete write of %s did not succeed.",fn);
  }

 /*
  * close file and return
  */
  if (close(fd) == -1) printf("\nd2disk.c : error closing %s.",fn);
  return;
} 
#endif
