/*
 * dCMult.c
 *
 *   Function computes a double complex product.  Output (yReal, yImag) is
 *   set equal to the product of the inputs (aReal,aImag) * (bReal,bImag).
 *
 *  jph 3/31/95
 */

#ifndef DCMULT_C
#define DCMULT_C
#include <stdio.h>
#include "teager2D.h"

void dCMult(yReal,yImag,aReal,aImag,bReal,bImag)

  double *yReal;    /* pointer to real part of product */
  double *yImag;    /* pointer to imag part of product */
  double  aReal;    /* real part of multiplicand */
  double  aImag;    /* imag part of multiplicand */
  double  bReal;    /* real part of multiplier */
  double  bImag;    /* imag part of multiplier */
  
{
  *yReal = (aReal * bReal) - (aImag * bImag);
  *yImag = (aReal * bImag) + (aImag * bReal);
  return;
} 
#endif
