/*
 * d_med.c
 *
 *   function computes the median of the pixel values of a double image.
 *
 *
 *  jph 22 June 1992
 */

#ifndef D_MED_C
#define D_MED_C
#include <stdio.h>
#include <math.h>
#include "teager2D.h"

double d_med(x,row_dim,col_dim)

  double* x;     /* input image */
  int row_dim;    /* row dimension of x */
  int col_dim;    /* col dimension of x */
{

  double max;        /* max pix value in x */
  double binsize;    /* max / 256  */
  int i;             /* loop counters */
  int N;             /* number of pixels in x */
  int No2;           /* N over 2 */
  int hist[256];     /* histogram of x */
  int ltmdn;         /* number of pix < current guess for median */

 /*
  * detect zero dimension input
  */
  if ((row_dim==0) || (col_dim==0)) return;

 /*
  *  Find max, binsize
  */
  No2 = (N = row_dim * col_dim) / 2;
  max = x[0];
  for (i=0; i<N; i++)
    if (x[i] > max) max = x[i];
  binsize = max / 256.0;

 /*
  * find median by histogram method
  */
  for (i=0; i<256; i++) hist[i] = 0;
  for (i=0; i<N; i++) hist[(int)(x[i]/binsize) - 1]++;
  for(i=-1,ltmdn=0; ltmdn<No2; ) {
    i++;
    ltmdn += hist[i];
  }

  return((double) i * binsize);
} 
#endif
