/*
 * dbx.c
 *
 *   function expands the dynamic range of a byte image to make full
 *   use of 8-bits
 *
 *
 *  jph 15 June 1992
 */

#ifndef DBX_C
#define DBX_C
#include <stdio.h>
#include "teager2D.h"

void dbx(x,row_dim,col_dim)

  unsigned char* x;     /* input image */
  int row_dim;    /* row dimension of x */
  int col_dim;    /* col dimension of x */
{

  int i;             /* loop counters */
  double min,max;    /* min and max pixel values in x */
  double factor;     /* multiplicative factor */

 /*
  * detect zero dimension input
  */
  if ((row_dim==0) || (col_dim==0)) return;


 /*
  * find min, max, and factor
  */
  max = min = x[0];
  for (i=0; i<row_dim * col_dim; i++) {
    if ((double)x[i] > max) max = x[i];
    else if ((double)x[i] < min) min = x[i];
  }

 /*
  * scale for maximum dynamic range
  */ 
  if (max == min) {
    printf("\ndbx : divide by zero, image has no dynamic range !");
    return;
  }
  else {
    for (i=0; i<row_dim*col_dim; i++)
      x[i] -= min;
    factor = (double) 255.0 / (max - min);
    b_scaleimage(x,row_dim,col_dim,factor);
  }
  return;
} 
#endif
