/*
 * disk2d.c
 *
 *   function reads a double image from disk
 *
 *
 *  jph 22 June 1992
 */

#ifndef DISK2D_C
#define DISK2D_C
#include <stdio.h>
#include <fcntl.h>
#include "teager2D.h"

void disk2d(x,row_dim,col_dim,fn)

  double *x;            /* image to be read */
  int row_dim;          /* row dimension of x */
  int col_dim;          /* col dimension of x */
  char *fn;             /* filename */
{

  int fd;               /* file descriptor */
  int n_bytes;          /* number of bytes to read */

 /*
  * detect zero dimension input
  */
  if ((row_dim==0) || (col_dim==0)) return;

 /*
  * create and open the file
  */
  if ((fd = open(fn, O_RDONLY))==-1) {
    printf("\ndisk2d.c : could not open %s !",fn);
    return;
  }

 /*
  * read image data from the file
  */
  n_bytes = row_dim * col_dim * sizeof(double);
  if (read(fd,x,n_bytes) != n_bytes) {
    printf("\ndisk2d.c : complete read of %s did not succeed.",fn);
  }

 /*
  * close file and return
  */
  if (close(fd) == -1) printf("\ndisk2d.c : error closing %s.",fn);
  return;
} 
#endif
