/*
 * disk2image.c
 *
 *   function reads an image from disk
 *
 *  jph 9/13/93
 */

#ifndef DISK2IMAGE_C
#define DISK2IMAGE_C
#include <stdio.h>
#include <fcntl.h>
#include "teager2D.h"

void *disk2image(row_dim,col_dim,fn,datatype)

  int row_dim;          /* row dimension of x */
  int col_dim;          /* col dimension of x */
  char *fn;             /* filename */
  char datatype;        /* type of image to be read: b=byte,d=double,f=float */
{

  int fd;               /* file descriptor */
  void *x;              /* image data */

 /*
  * read image data from the file
  */
  switch(datatype) {

    case 'd':  if ((x = (void *)malloc(row_dim*col_dim*sizeof(double)))==NULL) {
                 printf("\ndisk2image: free store exhausted.\n");
                 exit(-1);
               }
               disk2d((double *)x, row_dim, col_dim,fn);
               break;
    case 'f':  if ((x = (void *)malloc(row_dim*col_dim*sizeof(float)))==NULL) { 
                 printf("\ndisk2image: free store exhausted.\n");
                 exit(-1);
               }
               disk2f((float *)x, row_dim, col_dim,fn);
               break;
    case 'b':  if ((x = (void *) malloc(row_dim*col_dim*sizeof(BYTE)))==NULL) {
                 printf("\ndisk2image: free store exhausted.\n");
                 exit(-1);
               }
               disk2byte((BYTE *)x, row_dim, col_dim,fn);
               break;
    default:   printf("\ndisk2image: unknown data type %a",datatype);
               exit(-1);
               break;
  }
  return(x);

} 
#endif
