/*
 * double2byte.c
 *
 *   function converts a double image to unsigned char (byte).
 *   It is assumed that the image contains only values in the
 *   range [0,255].
 *
 *   the byte image is allocated on the stack, the double values
 *   are cast and copied into it, and a pointer to the new byte
 *   image is returned.
 *
 *  jph 15 June 1992
 */

#ifndef DOUBLE2BYTE_C
#define DOUBLE2BYTE_C
#include <stdio.h>
#include "teager2D.h"

unsigned char* double2byte(x,row_dim,col_dim)

  double* x;         /* input image */
  int row_dim;    /* row dimension of x */
  int col_dim;    /* col dimension of x */
{

  unsigned char *y;         /* pointer to output image */
  int i;             /* loop counters */

 /*
  * detect zero dimension input
  */
  if ((row_dim==0) || (col_dim==0)) return NULL;

 /* 
  * allocate memory for y, return error if out of memory
  */
  y = (unsigned char *) malloc(row_dim * col_dim * sizeof(unsigned char));
  if (y == NULL) {
    printf("\ndouble2byte.c : out of memory error !");
    return NULL;
  }

 /*
  * set y = x
  */
  for (i=0; i<row_dim * col_dim; i++) {
    y[i] = (unsigned char) x[i];
  }
  return y;
} 
#endif
