/*
 * f2d.c
 *
 *   function converts a float image to double.
 *
 *   the double image is allocated on the stack, the float values
 *   are cast and copied into it, and a pointer to the new double
 *   image is returned.
 *
 *  jph 24 July 1992
 */

#ifndef F2D_C
#define F2D_C
#include <stdio.h>
#include "teager2D.h"

double* f2d(x,row_dim,col_dim)

  float* x;         /* input image */
  int row_dim;    /* row dimension of x */
  int col_dim;    /* col dimension of x */
{

  double *y;         /* pointer to output image */
  int i;             /* loop counters */

 /*
  * detect zero dimension input
  */
  if ((row_dim==0) || (col_dim==0)) return NULL;

 /* 
  * allocate memory for y, return error if out of memory
  */
  y = (double *) malloc(row_dim * col_dim * sizeof(double));
  if (y == NULL) {
    printf("\nf2d.c : out of memory error !");
    return NULL;
  }

 /*
  * set y = x
  */
  for (i=0; i<row_dim * col_dim; i++) {
    y[i] = (double) x[i];
  }
  return y;
} 
#endif
