/*
 * f2disk.c
 *
 *   function writes a float image to disk
 *
 *
 *  jph 24 July 1992
 */

#ifndef F2DISK_C
#define F2DISK_C
#include <stdio.h>
#include <fcntl.h>
#include "teager2D.h"

void f2disk(x,row_dim,col_dim,fn)

  float *x;             /* image to be written */
  int row_dim;          /* row dimension of x */
  int col_dim;          /* col dimension of x */
  char *fn;             /* filename */
{

  int fd;               /* file descriptor */
  int n_bytes;          /* number of bytes to read */

 /*
  * detect zero dimension input
  */
  if ((row_dim==0) || (col_dim==0)) return;

 /*
  * create and open the file
  */
  if ((fd = open(fn, O_WRONLY | O_CREAT | O_TRUNC, 0644))==-1) {
    printf("\nf2disk.c : could not open file %s!",fn);
    return;
  }

 /*
  * write image data to the file
  */
  n_bytes = row_dim * col_dim * sizeof(float);
  if (write(fd,x,n_bytes) != n_bytes) {
    printf("\nf2disk.c : complete disk write of %s did not succeed.",fn);
  }

 /*
  * close file and return
  */
  if (close(fd) == -1) printf("\nf2disk.c : error in closing file.");
  return;
} 
#endif
