/*
 * fMakeFilterImage.c
 *
 * Function creates three float images of the specified 
 * filter.  Magnitude, Real component, and Imaginary component images are 
 * created.  The output images are allocated on the heap.
 *
 *  jph 2/9/95
 *
 */

#ifndef FMAKEFILTERIMAGE_C
#define FMAKEFILTERIMAGE_C
#define BYTE unsigned char
#include "teager2D.h"
#include <stdio.h>

void fMakeFilterImage(f,zerophase,size,R,I,M)

  FilterPtr   f;         /* filter to be evaluated */
  int         zerophase; /* 1: zero-phase filter, 0: filter centered in plane */
  int         size;      /* row (col) dimension of the image */
  float     **R;         /* float real component array */
  float     **I;         /* float imaginary component array */
  float     **M;         /* float magnitude array */

{


  *R = gMakeReal(f,zerophase,size);
  *I = gMakeImag(f,zerophase,size);
  *M = gMakeMag( f,zerophase,size);

}
#endif
