/*
 * fMakeFilterSpectrum.c
 *
 * Function creates a float image of the specified 
 * filter.  Since it is assumed to be a Gabor filter, the imaginary part is zero
 * and the magnitude equals the real part.
 * The output image are allocated on the heap.
 *
 *  jph 2/9/95
 *
 */

#ifndef FMAKEFILTERSPECTRUM_C
#define FMAKEFILTERSPECTRUM_C
#define BYTE unsigned char
#include "teager2D.h"
#include <stdio.h>

float *fMakeFilterSpectrum(f,size)

  FilterPtr   f;         /* filter to be evaluated */
  int         size;      /* row (col) dimension of the image */

{

  float      *R;         /* float real component array */

  R = GMakeReal(f,size);
  return(R);

}
#endif
