/*
 * fmean.c
 *
 *   function returns the mean of a float image.
 *
 *  jph 21 February 1996
 */

#ifndef FMEAN_C
#define FMEAN_C
#include <stdio.h>
#include <math.h>
#include "teager2D.h"

float fmean(x,row_dim,col_dim)

  float    *x;       /* input image */
  int       row_dim; /* row dimension of x */
  int       col_dim; /* col dimension of x */
{

  float    sum;      /* sum of pixel values in x */
  int      N;        /* number of pixels in x */
  int      i;        /* loop counter */
  float    mean;     /* computed mean pixel value in x */

 /*
  * detect zero dimension input
  */
  if ((row_dim==0) || (col_dim==0)) return((float)0.0);

 /*
  *  Find mean
  */
  N = row_dim * col_dim;
  for (sum=(float)0.0,i=0; i < N; i++) {
    sum += x[i];
  }
  mean = sum / (float) N;

  return(mean);
} 
#endif
