/*
 * image2disk.c
 *
 *   function writes an image to a binary disk file suitable for display
 *
 *  jph 19 Jan 1994
 */

#ifndef IMAGE2DISK_C
#define IMAGE2DISK_C
#include <stdio.h>
#include "teager2D.h"

void image2disk(x,row_dim,col_dim,datatype,fn)

  void *x;              /* image data */
  int row_dim;          /* row dimension of x */
  int col_dim;          /* col dimension of x */
  char datatype;        /* type of image to be read: b=byte,d=double,f=float */
  char *fn;             /* filename */
{

  void *xx;             /* image data converted to type BYTE */


  switch(datatype) {

    case 'd':  if ((xx = d_dbx((double *)x, row_dim, col_dim)) == NULL) {
                 printf("\nimage2disk: unrecoverable error in d_dbx.c\n");
                 return;
               }
               byte2disk(xx,row_dim,col_dim,fn);
               free(xx);
               break;
    case 'f':  if ((xx = f_dbx((float *)x, row_dim, col_dim)) == NULL) {
                 printf("\nimage2disk: unrecoverable error in f_dbx.c\n");
                 return;
               }
               byte2disk(xx,row_dim,col_dim,fn);
               free(xx);
               break;
    case 'b':  dbx(x,row_dim,col_dim);
               byte2disk(x,row_dim,col_dim,fn);
               break;
    default:   printf("\ndisk2image: unknown data type %a",datatype);
               return;
               break;
  }
  return;

} 
#endif
