/*
 * readasf.c
 *
 *   function reads an image from disk and returns the data as float, 
 *   performing type conversion as necessary.
 *
 *  jph 9/13/93
 */

#ifndef READASF_C
#define READASF_C
#include <stdio.h>
#include <fcntl.h>
#include "teager2D.h"

float *readasf(row_dim,col_dim,fn,datatype)

  int    row_dim;       /* row dimension of x */
  int    col_dim;       /* col dimension of x */
  char  *fn;            /* filename */
  char   datatype;      /* type of image to be read: b=byte,d=double,f=float */
{

  int     i;            /* loop counter */
  BYTE   *byteimage;    /* byte version of the image */
  float  *floatimage;   /* float version of the image */
  double *doubleimage;  /* double version of the image */

 /*
  * read image data from the file
  */
  switch(datatype) {

    case 'd':  doubleimage = (double *)disk2image(row_dim,col_dim,fn,datatype);
               floatimage  = d2f(doubleimage,row_dim,col_dim);
               free(doubleimage);
               return(floatimage);
               break;
    case 'f':  return((float *)disk2image(row_dim,col_dim,fn,datatype));
               break;
    case 'b':  byteimage =  (BYTE *)disk2image(row_dim,col_dim,fn,datatype);
               floatimage = byte2float(byteimage,row_dim,col_dim);
               free(byteimage);
               return(floatimage);
               break;
    default:   printf("\nreadasf: unknown data type %a",datatype);
               exit(-1);
               break;
  }
} 
#endif
