/*
 * v_dsply_needle.c
 *
 *   This modified version of dsply_needle.c displays on vision.
 *   Function displays a needle diagram on the Xterm.
 *   Plotting is done by calling GnuPlot.
 *
 *   After "writegnu.c" by Keith Bartels
 *
 *  jph 22 June 1992
 */

#ifndef V_DSPLY_NEEDLE_C
#define V_DSPLY_NEEDLE_C
#include <stdio.h>
#include <math.h>
#include "teager2D.h"

void v_dsply_needle(u,v,domain,row_dim,col_dim,heads,startrow,startcol,
                                                     stoprow,stopcol)

  double *u, *v;           /* needles in cartesian coordinates */
  unsigned char *domain;  /* nonzero where a needle should originate */
  int heads;
  int startrow,startcol,stoprow,stopcol;
{
  int row,col;            /* loop counters */
  int gnu_row, gnu_col;   /* loop counters */
  FILE  *gnufile;         /* temp file to hold gnuplot commands */
 
 /*
  * create the gnuplot command file
  */
  gnufile = fopen("___needle_tmp_gnu_file","w");
  /*fprintf(gnufile,"set nokey\nset size 0.525,0.75\nset grid\n");*/
  fprintf(gnufile,"set terminal x11\n");
  fprintf(gnufile,"set nokey\nset size 0.7,1\n");
  fprintf(gnufile,"set xlabel \" \"\n");
  fprintf(gnufile,"set ylabel \" \"\n");
 
  for (row=startrow,gnu_row=row_dim-startrow-1; row<stoprow; row++,gnu_row--)
    for (col=gnu_col=startcol; col<stopcol; col++,gnu_col++)
      if (domain[row*col_dim+col])
        if (heads) fprintf(gnufile,"set arrow from %d,%d to %f,%f \n",
          gnu_col,gnu_row,(float)gnu_col+(float)u[row*col_dim+col],
                          (float)gnu_row+(float)v[row*col_dim+col]);
        else fprintf(gnufile,"set arrow from %d,%d to %f,%f nohead\n",
          gnu_col,gnu_row,(float)gnu_col+(float)u[row*col_dim+col],
                          (float)gnu_row+(float)v[row*col_dim+col]);
/*if ((u[row*col_dim+col]!=0.0)||(v[row*col_dim+col]!=0.0))
        fprintf(gnufile,"set arrow from %d,%d to %f,%f \n",*/
  fprintf(gnufile,"plot [0:%d][0:%d] 0\n",col_dim-1,row_dim-1);
  fprintf(gnufile,"pause -1 \"<ENTER> to continue: \"\n");
  fclose(gnufile);
 
 /*
  * Do the plot
  */
  system("(export DISPLAY;DISPLAY=vision:0.0;gnuplot ___needle_tmp_gnu_file 2>/dev/null)");
  system("rm ___needle_tmp_gnu_file");

}
#endif
