
/*
 * AgeVUpdRecs.c
 *
 *   Contains function AgeVerticalUpdRecs
 *
 *   Called at the end of track processing for a row.  For a track,
 *   switch all the pointers in the VertUpd array and the NextVertUpd array.
 *   Then re-initialize the records pointed to by the NextVertUpd array.
 *
 * 7/28/94 jph
 */

#ifndef AGEVERTICALUPDRECS_C
#define AGEVERTICALUPDRECS_C

#include "track.h"

/*-----------------------------------------------------------------------------
   AGE VERTICAL UPD RECS
-----------------------------------------------------------------------------*/

void AgeVerticalUpdRecs(T,size)
 
  trackP  T;                    /* track */
  int          size;            /* row/col dimension of images */
 
{
 
  int     k;                    /* loop counter */
  UpdRecP TempUpdRecP;          /* temp ptr to a UpdRec */

  for (k=0; k < size; k++) {
    TempUpdRecP = T->VertUpd[k];
    T->VertUpd[k] = T->NextVertUpd[k];
    T->NextVertUpd[k] = TempUpdRecP;
    T->NextVertUpd[k]->LastChan = -1;
  } 

  return;
 
}/*--------------------------------------------  AgeVerticalUpdRecs  --------*/
#endif
