/*
 * AllocWAb.c
 *
 *   Allocate working arrays for trackb.c
 *
 * 3/11/96 jph
 */

#ifndef ALLOCWAB_C
#define ALLOCWAB_C

#include "track.h"
 
void AllocWAb(cmd,G,ReadSize,ChannelStatus,Qorder,ChannelQ,ChanQcopy,LastStart,
              Alast,Ulast,Vlast)

  char         *cmd;            /* argv[0] */
  filterbank   *G;              /* ptr to the filter bank */
  int           ReadSize;       /* size of a row of obs for A,U, or V */
  int         **ChannelStatus;  /* track assoc status of channel */
  int         **Qorder;         /* no.s of channels sorted by Q */
  float       **ChannelQ;       /* channel quality */
  float       **ChanQcopy;      /* copy of channel quality for sorting */
  image_point **LastStart;      /* for each chan, pix of last trackstart */
  float       **Alast;          /* last row of observations of A */
  float       **Ulast;          /* last row of observations of u */
  float       **Vlast;          /* last row of observations of v */
{
 
  int           i;              /* loop counter */

 /*
  * Allocate working arrays
  */
  if ((*ChannelStatus=(int *)malloc(G->TotNumFilters*sizeof(int))) == NULL) {
    printf("\n%s: free store exhausted.\n",cmd);
    exit(-1);
  }
  if ((*Qorder=(int *)malloc(G->TotNumFilters * sizeof(int))) == NULL) {
    printf("\n%s: free store exhausted.\n",cmd);
    exit(-1);
  }
  if ((*ChannelQ=(float *)malloc(G->TotNumFilters * sizeof(float))) == NULL){
    printf("\n%s: free store exhausted.\n",cmd);
    exit(-1);
  }
  if ((*ChanQcopy=(float *)malloc(G->TotNumFilters * sizeof(float)))
     == NULL) {
    printf("\n%s: free store exhausted.\n",cmd);
    exit(-1);
  }
  if ((*LastStart=(image_point *)malloc(G->TotNumFilters
                               *sizeof(image_point))) == NULL) {
    printf("\n%s: free store exhausted.\n",cmd);
    exit(-1);
  }
  for (i=0; i < G->TotNumFilters; i++) {
    (*LastStart)[i].row = (*LastStart)[i].col = -2 * NEW_START_RADIUS;
  }
  if ((*Alast = (float *)malloc(ReadSize)) == NULL) {
    printf("\n%s: free store exhausted.\n",cmd);
  }
  if ((*Ulast = (float *)malloc(ReadSize)) == NULL) {
    printf("\n%s: free store exhausted.\n",cmd);
  }
  if ((*Vlast = (float *)malloc(ReadSize)) == NULL) {
    printf("\n%s: free store exhausted.\n",cmd);
  }

  return;
}/*--------------------------------------------  AllocWAb  ------------------*/
#endif
