/*
 *
 * DomCompTKPF.c
 *
 *  This program does the same thing as DomComp.c, but it uses the TKEO
 *  and ESA instead of my demodulation algorithms.
 *
 *  THIS VERSION USES ALL REAL FILTERS.
 *  THIS VERSION COMPUTES A,U,V as images, then filters,
 *      then evaluates criterion.
 *  THIS VERSION DOES MEDIAN POSTFILTERING
 *
 *  This is a quick and dirty program... not clean at all!
 *
 *  usage: DomCompTK ParameterFileName
 *
 *  jph 2/13/98
 */

#ifndef DOMCOMPTKPF_C
#define DOMCOMPTKPF_C

#define MEDSIZE 7
#define PETROS_A_ALG
/*#define JOEBOB_A_ALG*/

#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <string.h>

#include "teager2D.h"

/*
 * Function prototypes
 */
void Initialize();
void ReadParametersFile();
void dom_esa();
void AllocArrays();
void DomRecon();
void InsertAsm();

main(argc,argv)

  int   argc;
  char *argv[];

{

  filterbank        *G;              /* the filter bank */
  pFloatImage        g;              /* postfilter image */
  pFloatImage        X;              /* input image */
  pFloatImage        Y;              /* filtered image */
  int                size;           /* row/col dim of the square input image */
  int                n;              /* size squared */
  int                i;              /* counter */
  int                j;              /* counter */
  int                k;              /* loop counter */
  int                m;              /* loop counter */
  int                row;            /* image row counter */
  int                col;            /* image col counter */
  int                looplim;        /* terminal value for a loop counter */
  int                ZeroPad;        /* 1 if zero padding is to be used */
  int                Reflect;        /* 1=fill 0 padded areas w/ reflection */
  int                ReconInterval;  /* boundary condition interval for recon */
  int               *maxfilt;        /* Which channel max'd criterion at i,j */
  int               *itmp;           /* temp int poineter */
  BYTE              *btmp;           /* temp byte pointer */
  float             *ftmp;           /* temp float pointer */
  double            *dtmp;           /* temp double pointer */
  float             *criterion;      /* filter selection criterion */
  float             *A;              /* A estimates accross all 40 filters */
  float             *Asm;            /* smoothed A estimates */
  float             *U;              /* U estimates accross all 40 filters */
  float             *Usm;            /* smoothed U estimates */
  float             *V;              /* V estimates accross all 40 filters */
  float             *Vsm;            /* smoothed V estimates */
  BYTE              *u_valid;        /* 1 where the u estimate is valid */
  BYTE              *v_valid;        /* 1 where the v estimate is valid */
  BYTE              *a_valid;        /* 1 where the a estimate is valid */
  float             *DomCompR;       /* Real part of the dominant component */
  float             *DomCompI;       /* Imag part of the dominant component */
  double            *Theta;          /* phase initial conditions for recon */
  int               *maxfiltFake;    /* fake maxfilt data */
  float             *criterionFake;  /* fake filter selection criterion */
  float             *AFake;          /* A est from a single channel */
  float             *UFake;          /* U est from a single channel */
  float             *VFake;          /* V est from a single channel */
  BYTE              *a_validFake;    /* 1 where fake a estimate is valid */
  BYTE              *u_validFake;    /* 1 where fake u estimate is valid */
  BYTE              *v_validFake;    /* 1 where fake u estimate is valid */
  double            *ThetaFake;      /* Fake phase initial conds for recon */
  char               Afn[FNSIZE];    /* filename for amplitude estimates */
  char               Ufn[FNSIZE];    /* filename for horiz freq estimates */
  char               Vfn[FNSIZE];    /* filename for vert  freq estimates */
  int                PrintResponse;  /* 1 if we are to print response images */
  char               MaxFiltfn[FNSIZE];  /* filename for maxfilt data */
  char               DomCompRfn[FNSIZE]; /* filename for Dom Comp Real data */
  char               DomCompIfn[FNSIZE]; /* filename for Dom Comp Imag data */
  char               RespRootFn[FNSIZE]; /* root filename for response images */
  int                PrintChannels;  /* 1=print A,U,V est. from each channel */
  char               ChanARootFn[FNSIZE];/* root fn for Channel A estimates */
  char               ChanURootFn[FNSIZE];/* root fn for Channel U estimates */
  char               ChanVRootFn[FNSIZE];/* root fn for Channel V estimates */
  char               TempString[FNSIZE]; /* string for building up filenames */
  int                PostFilter;     /* 1 if postfiltering is to be done */
  char               ChanAsmRootFn[FNSIZE];/* Filename for smoothed amplitude */
  char               ChanUsmRootFn[FNSIZE];/* Filename for smoothed horiz freq*/
  char               ChanVsmRootFn[FNSIZE];/* Filename for smoothed vert  freq*/

 /*
  * Check for right number of arguments
  */
  if (argc != 2) {
    printf("\n\n%s: dominant component AM/FM analysis using TKEO.",argv[0]);
    printf("\nusage: %s ParameterFileName\n",argv[0]);
    exit(-1);
  }
#ifdef DEBUG
 /*
  * Link to PA so we can use it in the debugger 
  */
  if (!argc) {
    PA((void *)X, 0, -1, 'b');
    PRINTA((void *)X,0,-1,'b',"delete.me");
    WRITEA((void *)X,0,-1,'b',"delete.me");
    image2disk((void *)X,1,1,'*',"delete.me");
    SpecMag2disk(X,"delete.me");
    PC(X,0,0,-1,'b',0);
    PRINTC(X,0,0,-1,'b',0,"delete.me");
    WRITEC(X,0,0,-1,'b',0,"delete.me");
  }
#endif
  X = (pFloatImage)malloc(sizeof(FloatImage));
  Y = (pFloatImage)malloc(sizeof(FloatImage));

  Initialize(argv[1],&size,&ZeroPad,&Reflect,&X->Real,&X->Imag,&X->FFTReal,
             &X->FFTImag,&G,Afn,Ufn,Vfn,MaxFiltfn,DomCompRfn,DomCompIfn,
             &PrintResponse,RespRootFn,&PrintChannels,ChanARootFn,ChanURootFn,
             ChanVRootFn,&ReconInterval,&PostFilter,ChanAsmRootFn,ChanUsmRootFn,
             ChanVsmRootFn);
  X->size = X->cols = X->rows = size;
  X->square = 1; 
  AllocFloatImage(Y,size);
  n = size * size;

 /*
  * Allocate working arrays
  */
  AllocArrays(argv,n,PrintChannels,PostFilter,&a_valid,&u_valid,&v_valid,
              &maxfilt,&criterion,&A,&U,&V,&Asm,&Usm,&Vsm,&a_validFake,
              &u_validFake,&v_validFake,&maxfiltFake,&criterionFake,&AFake,
              &UFake,&VFake,&Theta,&ThetaFake);
  if (PrintResponse) {
    printf("\n\nGenerating Files for Channel Responses...\n");
  }
  if (PrintChannels) {
    printf("\n\nGenerating files for A,U estimates from each channel...\n");
  }
  if (PostFilter) {
    printf("\n\nPost Filtering...\n");
  }

 /*
  * Process with the zeroth filter
  */
  if (ZeroPad) {
    looplim = size >> 1;
  } else {
    looplim = size;
  }
  printf("\nDoing Filter 0...");
  /*  Here begins the filtering ----------------------*/
  free(Y->Real);
  Y->Real = gMakeReal(G->filt[0],1,size);
  for (m=0; m < size*size; m++) {
    Y->Imag[m] = (float)0.0;
  }
  fft2d(Y->Real,Y->Imag,Y->FFTReal,Y->FFTImag,size,1);
  Filter(Y,X);
  /*  Here ends the filtering ----------------------*/

  if (PrintResponse) {
    if (strcmp(RespRootFn,"none")) {
      sprintf(TempString,"%s%02dR.float",RespRootFn,0);
      f2disk(Y->Real,Y->size,Y->size,TempString);
      sprintf(TempString,"%s%02dI.float",RespRootFn,0);
      f2disk(Y->Imag,Y->size,Y->size,TempString);
    }
  }

 /*
  * Dominant ESA
  */
  dom_esa(Y,looplim,G->filt[0],criterion,A,U,V,G,maxfilt,a_valid,u_valid,
          v_valid,ReconInterval,Theta);

 /*
  * Re-run ESA with fake variables if PrintChannels OR PostFiltering
  */
  if (PrintChannels || PostFilter) {
    dom_esa(Y,looplim,G->filt[0],criterionFake,AFake,UFake,VFake,G,maxfiltFake,
            a_validFake,u_validFake,v_validFake,ReconInterval,ThetaFake);

   /*
    * Post Filter U, V and A
    */
    if (PostFilter) {
      if (G->filt[0]->isotropicPF) {
        g = MkPostFilt(G->filt[0]->sigma,G->filt[0]->kappa,size);
      } else {
        g = MkAnisPF(G->filt[0]->sigma,G->filt[0]->kappa_x,G->filt[0]->kappa_y,
                     G->filt[0]->Theta,size,1);
      }
      DoPostFilter(g,size,UFake,Usm,G,0);
      DoPostFilter(g,size,VFake,Vsm,G,0);
      ReComputeAsm(Y,Usm,Vsm,Asm,G->filt[0]);
      DoPostFilter(g,size,Asm,Asm,G,0);
      InsertAsm(Asm,A,maxfilt,size,0);
      InsertAsm(Usm,U,maxfilt,size,0);
      InsertAsm(Vsm,V,maxfilt,size,0);
      g = KillFloat(g);

     /*
      * Print smoothed A,U,V estimates for this channel
      */
      if (PrintChannels) {
        if (strcmp(ChanAsmRootFn,"none")) {
          sprintf(TempString,"%s%02d.float",ChanAsmRootFn,0);
          f2disk(Asm,Y->size,Y->size,TempString);
        }
        if (strcmp(ChanUsmRootFn,"none")) {
          sprintf(TempString,"%s%02d.float",ChanUsmRootFn,0);
          f2disk(Usm,Y->size,Y->size,TempString);
        }
        if (strcmp(ChanVsmRootFn,"none")) {
          sprintf(TempString,"%s%02d.float",ChanVsmRootFn,0);
          f2disk(Vsm,Y->size,Y->size,TempString);
        }
      }
    }

    if (PrintChannels) {
      if (strcmp(ChanARootFn,"none")) {
        sprintf(TempString,"%s%02d.float",ChanARootFn,0);
        f2disk(AFake,Y->size,Y->size,TempString);
      }
      if (strcmp(ChanURootFn,"none")) {
        sprintf(TempString,"%s%02d.float",ChanURootFn,0);
        f2disk(UFake,Y->size,Y->size,TempString);
      }
      if (strcmp(ChanVRootFn,"none")) {
        sprintf(TempString,"%s%02d.float",ChanVRootFn,0);
        f2disk(VFake,Y->size,Y->size,TempString);
      }
    }       /* if (PrintChannels) */

    for (j=0; j < n; j++) {
      criterionFake[j] = (float)-1.0;
      AFake[j] = (float)0.0;
      UFake[j] = (float)0.0;
      VFake[j] = (float)0.0;
      maxfiltFake[j] = -1;
      a_validFake[j] = 0;
      u_validFake[j] = 0;
      v_validFake[j] = 0;
    }
  }         /* if (PrintChannels || PostFilter) */

 /*
  * Loop for remaining filters
  */
  for (i=1; i < G->TotNumFilters; i++) {
    printf("\nDoing Filter %d...",i);
    /*  Here begins the filtering ----------------------*/
    free(Y->Real);
    Y->Real = gMakeReal(G->filt[i],1,size);
    for (m=0; m < size*size; m++) {
      Y->Imag[m] = (float)0.0;
    }
    fft2d(Y->Real,Y->Imag,Y->FFTReal,Y->FFTImag,size,1);
    Filter(Y,X);
    /*  Here ends the filtering ----------------------*/
    if (PrintResponse) {
      if (strcmp(RespRootFn,"none")) {
        sprintf(TempString,"%s%02dR.float",RespRootFn,i);
        f2disk(Y->Real,Y->size,Y->size,TempString);
        sprintf(TempString,"%s%02dI.float",RespRootFn,i);
        f2disk(Y->Imag,Y->size,Y->size,TempString);
      }
    }

   /*
    * Dominant ESA
    */
    dom_esa(Y,looplim,G->filt[i],criterion,A,U,V,G,maxfilt,a_valid,u_valid,
            v_valid,ReconInterval,Theta);

   /*
    * Re-run ESA with fake variables if PrintChannels OR PostFiltering
    */
    if (PrintChannels || PostFilter) {
      dom_esa(Y,looplim,G->filt[i],criterionFake,AFake,UFake,VFake,G,
              maxfiltFake,a_validFake,u_validFake,v_validFake,ReconInterval,
              ThetaFake);

     /*
      * Post Filter U, V and A
      */
      if (PostFilter) {
        if (G->filt[i]->isotropicPF) {
          g = MkPostFilt(G->filt[i]->sigma,G->filt[i]->kappa,size);
        } else {
          g = MkAnisPF(G->filt[i]->sigma,G->filt[i]->kappa_x,
                       G->filt[i]->kappa_y,G->filt[i]->Theta,size,1);
        }
        DoPostFilter(g,size,UFake,Usm,G,i);
        DoPostFilter(g,size,VFake,Vsm,G,i);
        ReComputeAsm(Y,Usm,Vsm,Asm,G->filt[i]);
        DoPostFilter(g,size,Asm,Asm,G,i);
        InsertAsm(Asm,A,maxfilt,size,i);
        InsertAsm(Usm,U,maxfilt,size,i);
        InsertAsm(Vsm,V,maxfilt,size,i);
        g = KillFloat(g);

       /*
        * Print smoothed A,U,V estimates for this channel
        */
        if (PrintChannels) {
          if (strcmp(ChanAsmRootFn,"none")) {
            sprintf(TempString,"%s%02d.float",ChanAsmRootFn,i);
            f2disk(Asm,Y->size,Y->size,TempString);
          }
          if (strcmp(ChanUsmRootFn,"none")) {
            sprintf(TempString,"%s%02d.float",ChanUsmRootFn,i);
            f2disk(Usm,Y->size,Y->size,TempString);
          }
          if (strcmp(ChanVsmRootFn,"none")) {
            sprintf(TempString,"%s%02d.float",ChanVsmRootFn,i);
            f2disk(Vsm,Y->size,Y->size,TempString);
          }
        }
      }      /* if (PostFilter) */

      if (PrintChannels) {
        if (strcmp(ChanARootFn,"none")) {
          sprintf(TempString,"%s%02d.float",ChanARootFn,i);
          f2disk(AFake,Y->size,Y->size,TempString);
        }
        if (strcmp(ChanURootFn,"none")) {
          sprintf(TempString,"%s%02d.float",ChanURootFn,i);
          f2disk(UFake,Y->size,Y->size,TempString);
        }
        if (strcmp(ChanVRootFn,"none")) {
          sprintf(TempString,"%s%02d.float",ChanVRootFn,i);
          f2disk(VFake,Y->size,Y->size,TempString);
        }
      }       /* if (PrintChannels) */

      for (j=0; j < n; j++) {
        criterionFake[j] = (float)-1.0;
        AFake[j] = (float)0.0;
        UFake[j] = (float)0.0;
        VFake[j] = (float)0.0;
        maxfiltFake[j] = -1;
        a_validFake[j] = 0;
        u_validFake[j] = 0;
        v_validFake[j] = 0;
      }
    }            /* if (PrintChannels || PostFilter) */
  }              /* for i */

 /*
  * Resize results and valid arrays 
  */
  if (ZeroPad) {
    size >>= 1;
    itmp = (int   *)malloc(size*size*sizeof(int));
    for (row=0; row < size; row++) {
      memcpy(itmp+row*size,maxfilt+row*(size>>1),size*sizeof(int));
    }
    free(maxfilt);
    maxfilt = itmp;

    ftmp = (float *)malloc(size*size*sizeof(float));
    btmp = (BYTE  *)malloc(size*size*sizeof(BYTE));
    for (row=0; row < size; row++) {
      memcpy(ftmp+row*size,A+row*(size<<1),size*sizeof(float));
      memcpy(btmp+row*size,a_valid+row*(size<<1),size*sizeof(BYTE));
    }
    free(A);
    free(a_valid);
    A = ftmp;
    a_valid = btmp;

    ftmp = (float *)malloc(size*size*sizeof(float));
    btmp = (BYTE  *)malloc(size*size*sizeof(BYTE));
    for (row=0; row < size; row++) {
      memcpy(ftmp+row*size,U+row*(size<<1),size*sizeof(float));
      memcpy(btmp+row*size,u_valid+row*(size<<1),size*sizeof(BYTE));
    } 
    free(U);
    free(u_valid);
    U = ftmp;
    u_valid = btmp;

    ftmp = (float *)malloc(size*size*sizeof(float));
    btmp = (BYTE  *)malloc(size*size*sizeof(BYTE));
    for (row=0; row < size; row++) {
      memcpy(ftmp+row*size,V+row*(size<<1),size*sizeof(float));
      memcpy(btmp+row*size,v_valid+row*(size<<1),size*sizeof(BYTE));
    } 
    free(V);
    free(v_valid);
    V = ftmp;
    v_valid = btmp;

    dtmp = (double *)malloc(size*size*sizeof(double));
    for (row=0; row < size; row++) {
      memcpy(dtmp+row*size,Theta+row*(size<<1),size*sizeof(double));
    } 
    free(Theta);
    Theta = dtmp;
  }

  for (row=i=0; i < size*size; i++) {
    if (!a_valid[i]) {
      row++;
    }
  }
  printf("\nThe number of Bad A's is %d",row);

 /*
  * Interpolate for yet indeterminate values
  */
  for (i=0,row=0; row<size; row++) {
    for (col=0; col<size; col++,i++) {
      if (!u_valid[i]) f_interp(U,row,col,size,size,u_valid);
      if (!v_valid[i]) f_interp(V,row,col,size,size,v_valid);
      if (!a_valid[i]) f_interp(A,row,col,size,size,a_valid);
    }    /* for col */
  }      /* for row */

 /*
  * Reconstruct Dominant Component
  */
  DomRecon(A,U,V,size,&DomCompR,&DomCompI,ReconInterval,Theta);

 /*
  * Write result files
  */
  if (strcmp(Afn,"none")) {
    f2disk(A,looplim,looplim,Afn);
  }
  if (strcmp(Ufn,"none")) {
    f2disk(U,looplim,looplim,Ufn);
  }
  if (strcmp(Vfn,"none")) {
    f2disk(V,looplim,looplim,Vfn);
  }
  if (strcmp(DomCompRfn,"none")) {
    f2disk(DomCompR,looplim,looplim,DomCompRfn);
  }
  if (strcmp(DomCompIfn,"none")) {
    f2disk(DomCompI,looplim,looplim,DomCompIfn);
  }
  if (strcmp(MaxFiltfn,"none")) {
    byte2disk(maxfilt,looplim*sizeof(int),looplim*sizeof(int),MaxFiltfn);
  }

/* remove these diagnostic lines here here here */
for (row=i=0; i < size*size; i++) {
  if (criterion[i] == (float)-1.0) {
    row++;
  }
}
printf("\nThe number of BAD pixels is %d",row);
 
  printf("\n\n");
  return;

} /*-------------------------------------------- main --------------*/

/*
 * Initialize
 *
 *  Process the paramters file
 *  Read the input image, if real make hardy to get the imaginary part
 *  Compute the input spectrum
 *  Construct the filter bank
 */

void Initialize(ParmFn,size,ZP,Reflect,xReal,xImag,XReal,XImag,G,Afn,Ufn,Vfn,
                MaxFiltfn,DomCompRfn,DomCompIfn,PrintResponse,RespRootFn,
                PrintChannels,ChanARootFn,ChanURootFn,ChanVRootFn,ReconInterval,
                PostFilter,ChanAsmRootFn,ChanUsmRootFn,ChanVsmRootFn)

  char        *ParmFn;           /* filename of parameters file */
  int         *size;             /* row/col dim of the square input image */
  int         *ZP;               /* 1 if zero padding is to be used */
  int         *Reflect;          /* 1=fill 0 padded areas w/ reflection */
  float      **xReal;            /* real part of input image */
  float      **xImag;            /* imag part of input image */
  float      **XReal;            /* real part of input spectrum */
  float      **XImag;            /* imag part of input spectrum */
  filterbank **G;                /* the filter bank */
  char        *Afn;              /* filename for Amplitude Estimates */
  char        *Ufn;              /* filename for horiz frequency estimates */
  char        *Vfn;              /* filename for vert  frequency estimates */
  char        *MaxFiltfn;        /* filename for maxfilt data */
  char        *DomCompRfn;       /* filename for Real dom comp data */
  char        *DomCompIfn;       /* filename for Imag dom comp data */
  int         *PrintResponse;    /* 1 if we are to print the response images */
  char        *RespRootFn;       /* Root filename for response images */
  int         *PrintChannels;    /* 1=print A,U est from each channel */
  char        *ChanARootFn;      /* root fn for A est from each channel */
  char        *ChanURootFn;      /* root fn for U est from each channel */
  char        *ChanVRootFn;      /* root fn for V est from each channel */
  int         *ReconInterval;    /* boundary condition interval for recon */
  int         *PostFilter;       /* 1=PostFiltering to be performed */
  char        *ChanAsmRootFn;    /* Filename for smoothed amplitude */
  char        *ChanUsmRootFn;    /* Filename for smoothed horiz frequency */
  char        *ChanVsmRootFn;    /* Filename for smoothed vert  frequency */
{

  int         i;                 /* counter */
  int         row;               /* counter for image rows */
  int         col;               /* counter for image cols */
  int         so2;               /* *size / 2 */
  char        datatype;          /* type of in dat: b=byte f=float d=double */
  int         Conjugate;         /* 1=conjugate input.  See Book X, p. 64 */
  char        Rfn[FNSIZE];       /* file for Real part of input image */
  char        Ifn[FNSIZE];       /* file for Imag part of input image */
  double      r0;                /* rad. center freq. of 1st filt on each ray */
  float       R;                 /* common ratio of radii of adjcnt filtrs */
  float       obw;               /* Eta-peak octave bandwidth of filters */
  float       Eta;               /* OBW is defined in terms of Eta-peak. */
  int         isoPF;             /* 1=isotropic post filters */
  float       kappa;             /* Post Filter space constant scale factor */
  float       kappa_x;           /* postfilter horiz space cnst scale factor */
  float       kappa_y;           /* postfilter vert  space cnst scale factor */
  float      *tfloat;            /* temporary float array */
  float      *to;                /* area in memory to copy floats to */
  float      *from;              /* area in memory to copy floats from */
  float      *pfloat;            /* ptr to location to fill w/ zero */

 /*
  * Read the parameter file
  */
  ReadParametersFile(ParmFn,&datatype,&Conjugate,Rfn,Ifn,size,ZP,Reflect,&r0,
                     &R,&Eta,&obw,Afn,Ufn,Vfn,MaxFiltfn,DomCompRfn,DomCompIfn,
                     PrintResponse,RespRootFn,PrintChannels,ChanARootFn,
                     ChanURootFn,ChanVRootFn,ReconInterval,PostFilter,&isoPF,
                     &kappa,&kappa_x,&kappa_y,ChanAsmRootFn,ChanUsmRootFn,
                     ChanVsmRootFn);
  r0 = r0 / (double)(*size);
 
 /*
  * If zero padding, double size 
  */
  if (*ZP) {
    *size *= 2;
  }
  so2 = *size >> 1;

 /*
  * Make the filter bank
  */ 
  *G = CreateFilterBank(r0,R,obw,Eta,isoPF,kappa,kappa_x,kappa_y);

 /*
  * Allocate Spectra
  */
  if ((*XReal = (float *)malloc(*size**size*sizeof(float))) == NULL) {
    printf("\nInitialize: free store exhausted\n");
    exit(-1);
  }
  if ((*XImag = (float *)malloc(*size**size*sizeof(float))) == NULL) {
    printf("\nInitialize: free store exhausted\n");
    exit(-1);
  }

 /*
  * Get the input image and its spectrum
  */
  if (*ZP) {
    tfloat = readasf(so2,so2,Rfn,datatype);
    if ((*xReal = (float *)malloc(*size**size*sizeof(float))) == NULL) {
      printf("\nInitialize: free store exhausted\n");
      exit(-1);
    }
    for (to=*xReal,from=tfloat,row=0; row < so2; row++,to+=*size,from+=so2) {
      memcpy(to, from, so2*sizeof(float));
      for (pfloat=to+so2,col=so2; col < *size; col++) {
        if (!*Reflect) {
          *(pfloat++) = (float)0.0;
        } else {
          *(pfloat++) = *(to + *size-col-1);
        }
      }
    }
    free(tfloat);
    if (!*Reflect) {
      for (pfloat=to,i=so2**size; i < *size**size; i++) {
        *(pfloat++) = (float)0.0;
      }
    } else {
      for (pfloat=to,row=1; row < *size; row+=2) {
        for (col=0; col < *size; col++,pfloat++) {
          *pfloat = *(pfloat - row**size);
        }
      }
    }
  } else {
    *xReal = readasf(*size,*size,Rfn,datatype);
  }

  if (strcmp(Ifn,"none")) {                     /* filename is not "none" */
    if (*ZP) {
      tfloat = readasf(so2,so2,Ifn,datatype);
      if ((*xImag = (float *)malloc(*size**size*sizeof(float))) == NULL) {
        printf("\nInitialize: free store exhausted\n");
        exit(-1);
      }
      for (to=*xImag,from=tfloat,row=0; row < so2; row++,to+=*size,from+=so2) {
        memcpy(to, from, so2*sizeof(float));
        for (pfloat=to+so2,col=so2; col < *size; col++) {
          if (!*Reflect) {
            *(pfloat++) = (float)0.0;
          } else {
            *(pfloat++) = *(to + *size-col-1);
          }
        }
      }
      free(tfloat);
      if (!*Reflect) {
        for (pfloat=to,i=so2**size; i < *size**size; i++) {
          *(pfloat++) = (float)0.0;
        }
      } else {
        for (pfloat=to,row=1; row < *size; row+=2) {
          for (col=0; col < *size; col++,pfloat++) {
            *pfloat = *(pfloat - row**size);
          }
        }
      }
    } else {
      *xImag = readasf(*size,*size,Ifn,datatype);
    }
    if (Conjugate) {
      for (i=0; i < *size**size; i++) {
        (*xImag)[i] *= (float)-1.0;
      }
    }
/*    f_u_norm(*xReal, *xImag, *size, *size);*/
    fft2d(*xReal,*xImag,*XReal,*XImag,*size,1);
  } else {                         /* input is real, must create imag part */
/*    f_u_norm(*xReal, NULL, *size, *size);*/
    if ((*xImag = (float *)malloc(*size**size*sizeof(float))) == NULL) {
      printf("\nInitialize: free store exhausted\n");
      exit(-1);
    }
/*    MakeHardy(*xReal,*xImag,*XReal,*XImag,*size);*/
    for (i=0; i < *size**size; i++) {
      (*xImag)[i] = (float)0.0;
    }
    fft2d(*xReal,*xImag,*XReal,*XImag,*size,1);
  }

  return;
} /*---------------------------------------------- Initialize ----------*/

/*
 * ReadParametersFile
 *
 *  read the data out of the parameters file
 *
 */

void ReadParametersFile(ParmFn,pdatatype,pConjugate,Rfn,Ifn,psize,pZP,pReflect,
                        pr0,pR,pEta,pobw,Afn,Ufn,Vfn,MaxFiltfn,DomCompRfn,
                        DomCompIfn,pPrintResponse,RespRootFn,pPrintChannels,
                        ChanARootFn,ChanURootFn,ChanVRootFn,pReconInterval,
                        pPostFilter,pisoPF,pkappa,pkappa_x,pkappa_y,
                        ChanAsmRootFn,ChanUsmRootFn,ChanVsmRootFn)
  char   *ParmFn;
  char   *pdatatype;
  int    *pConjugate;
  char   *Rfn;
  char   *Ifn;
  int    *psize;
  int    *pZP;
  int    *pReflect;
  double *pr0;
  float  *pR;
  float  *pEta;
  float  *pobw;
  char   *Afn;
  char   *Ufn;
  char   *Vfn;
  char   *MaxFiltfn;
  char   *DomCompRfn;
  char   *DomCompIfn;
  int    *pPrintResponse;
  char   *RespRootFn;
  int    *pPrintChannels;
  char   *ChanARootFn;
  char   *ChanURootFn;
  char   *ChanVRootFn;
  int    *pReconInterval;
  int    *pPostFilter;
  int    *pisoPF;
  float  *pkappa;
  float  *pkappa_x;
  float  *pkappa_y;
  char   *ChanAsmRootFn;
  char   *ChanUsmRootFn;
  char   *ChanVsmRootFn;
{

  FILE      *parmfp;            /* ptr to parameter file */
  char       instr[256];        /* buffer to read into  */

  if ((parmfp = fopen(ParmFn,"r")) == NULL) {
    printf("\n\nReadParametersFile: unable to open %s\n",ParmFn);
    exit(-1);
  }

  fscanf(parmfp,"Input Data Type= %s\n",instr);
  *pdatatype = instr[0];
  fscanf(parmfp,"Conjugate Input= %s\n",instr);
  if ((instr[0] == 'N') || (instr[0] == 'n')) {
    *pConjugate = 0;
  }
  else {
    *pConjugate = 1;
  }
  fscanf(parmfp,"Real Image File= %s\n",Rfn);
  fscanf(parmfp,"Imag Image File= %s\n",Ifn);
  fscanf(parmfp,"Size= %d\n",psize);
  fscanf(parmfp,"Zero Pad= %s\n",instr);
  if ((instr[0] == 'Y') || (instr[0] == 'y')) {
    *pZP = 1;
  }
  else {
    *pZP = 0;
  }
  fscanf(parmfp,"Reflect= %s\n",instr);
  if ((instr[0] == 'Y') || (instr[0] == 'y')) {
    *pReflect = 1;
  }
  else {
    *pReflect = 0;
  }
  fscanf(parmfp,"r0= %lf\n",pr0);
  fscanf(parmfp,"R= %f\n",pR);
  fscanf(parmfp,"Eta= %f\n",pEta);
  fscanf(parmfp,"OBW= %f\n",pobw);
  fscanf(parmfp,"A File= %s\n",Afn);
  fscanf(parmfp,"U File= %s\n",Ufn);
  fscanf(parmfp,"V File= %s\n",Vfn);
  fscanf(parmfp,"MaxFilt File= %s\n",MaxFiltfn);
  fscanf(parmfp,"Dominant Component Real File= %s\n",DomCompRfn);
  fscanf(parmfp,"Dominant Component Imag File= %s\n",DomCompIfn);
  fscanf(parmfp,"Print Response Images= %s\n",instr);
  if ((instr[0] == 'N') || (instr[0] == 'n')) {
    *pPrintResponse = 0;
  }
  else {
    *pPrintResponse = 1;
  }
  fscanf(parmfp,"Response Root File Name= %s\n",RespRootFn);
  fscanf(parmfp,"Print Channel Estimates= %s\n",instr);
  if ((instr[0] == 'N') || (instr[0] == 'n')) {
    *pPrintChannels = 0;
  }
  else {
    *pPrintChannels = 1;
  }
  fscanf(parmfp,"Chan Est A Root File Name= %s\n",ChanARootFn);
  fscanf(parmfp,"Chan Est U Root File Name= %s\n",ChanURootFn);
  fscanf(parmfp,"Chan Est V Root File Name= %s\n",ChanVRootFn);
  fscanf(parmfp,"Reconstruction Interval= %d\n",pReconInterval);
  fscanf(parmfp,"Postfilter= %s\n",instr);
  if ((instr[0] == 'N') || (instr[0] == 'n')) {
    *pPostFilter = 0;
  }
  else {
    *pPostFilter = 1;
  }
  fscanf(parmfp,"Isotropic PF= %s\n",instr);
  if ((instr[0] == 'N') || (instr[0] == 'n')) {
    *pisoPF = 0;
  }
  else {
    *pisoPF = 1;
  }
  fscanf(parmfp,"kappa= %f\n",pkappa);
  fscanf(parmfp,"kappa_x= %f\n",pkappa_x);
  fscanf(parmfp,"kappa_y= %f\n",pkappa_y);
  fscanf(parmfp,"Chan Asm Root Fn= %s\n",ChanAsmRootFn);
  fscanf(parmfp,"Chan Usm Root Fn= %s\n",ChanUsmRootFn);
  fscanf(parmfp,"Chan Vsm Root Fn= %s\n",ChanVsmRootFn);
  fclose(parmfp);
  return;
} /*--------------------------- ReadParametersFile -------------------------*/

/*
 * dom_esa
 *
 *  function evaluates the TKEO esa at every point in an image and checks to 
 *  see if the current response image has the dominant response of those 
 *  yet seen.
 *
 */

void dom_esa(X,looplim,G,criterion,a,u,v,Bank,maxfilt,a_valid,u_valid,v_valid,
             ReconInterval,Theta)

  pFloatImage     X;              /* response image */
  int             looplim;        /* terminal value for a loop counter */
  FilterPtr       G;              /* Y was output from this filter */
  float          *criterion;      /* filter selection criterion */
  float          *a;              /* a estimates */
  float          *u;              /* u estimates */
  float          *v;              /* v estimates */
  filterbank     *Bank;           /* the filterbank */
  int            *maxfilt;        /* which chan max'd criterion @ (i,j) */
  BYTE           *a_valid;        /* 1 where the a estimate is valid */
  BYTE           *u_valid;        /* 1 where the u estimate is valid */
  BYTE           *v_valid;        /* 1 where the v estimate is valid */
  int             ReconInterval;  /* boundary condition interval for recon */
  double         *Theta;          /* phase initial conditions for recon */
{

  int             row,col;        /* loop counters for image coordinates */
  int             k;              /* loop counter for indexing arrays */
  int             n1m2;           /* cursor */
  int             n1m1;           /* cursor */
  int             n1;             /* cursor */
  int             n1p1;           /* cursor */
  int             n1p2;           /* cursor */
  int             n2m2;           /* cursor */
  int             n2m1;           /* cursor */
  int             n2;             /* cursor */
  int             n2p1;           /* cursor */
  int             n2p2;           /* cursor */
  int             size;           /* X->size */
  float          *f;              /* X->Real */
  float          *A;              /* TKEO on the unshifted image */
  float          *B;              /* Phi[f(n1+1,n2) - f(n1-1,n2)] */
  float          *C;              /* Phi[f(n1,n2+1) - f(n1,n2-1)] */
  float          *Ahat;           /* ESA amplitude estimate */
  float          *Uhat;           /* ESA horiz freq estimate in radians */
  float           Ucps;           /* ESA horiz freq estimate in Hz */
  float          *Vhat;           /* ESA vert  freq estimate in radians */
  float           Vcps;           /* ESA vert  freq estimate in Hz */
  float           Adenom;         /* denominator of smoothed A alg */
  float          *Smooth;         /* smoothed result */
  int             Afail;          /* diagnostic variable */
  int             Bfail;          /* diagnostic variable */
  int             Cfail;          /* diagnostic variable */
  int             BpCfail;        /* diagnostic variable */
  int             GoodCount;      /* diagnostic variable */
  int             Winners;        /* diagnostic variable */
  int             BadA;           /* diagnostic variable */
  float           FilterMag;      /* magnitude of filter at estimated u,v */
  float           Gamma;          /* temp value of filter selection criterion */
  BYTE            A_VALID_FLAG;   /* switch=0 if FilterMag too small */
  BYTE            WINNER;         /* switch=1 if this pixel is a winner */
  BYTE            GOOD;           /* switch=1 if this pixel is good */
  double          CosTheta;       /* cosine of Theta */
  double          Usin;           /* sine of U */
  double          Vsin;           /* sine of V */

  Winners = GoodCount = BadA = Afail = Bfail = Cfail = BpCfail = 0;
  f    = X->Real;
  size = X->size;
  Ahat = (float *)malloc(size*size*sizeof(float));
  Uhat = (float *)malloc(size*size*sizeof(float));
  Vhat = (float *)malloc(size*size*sizeof(float));
  A    = (float *)malloc(size*size*sizeof(float));
  B    = (float *)malloc(size*size*sizeof(float));
  C    = (float *)malloc(size*size*sizeof(float));

  for (k=0; k < size*size; k++) {
    Ahat[k] = Uhat[k] = Vhat[k] = A[k] = B[k] = C[k] = (float)0.0;
  }

  for (row=0; row < X->size; row++) {
    for (col=0; col < X->size; col++) {

      k = row*size + col;
      WINNER = GOOD = 0;

      /* setup indices */
      n1m2 = col - 2;
      n1m1 = col - 1;
      n1   = col;
      n1p1 = col + 1;
      n1p2 = col + 2;

      n2m2 = row - 2;
      n2m1 = row - 1;
      n2   = row;
      n2p1 = row + 1;
      n2p2 = row + 2;

      /* Check that indices are in range */
      if (n1m2 < 0)     n1m2 = 0;
      if (n1m2 >= size) n1m2 = size-1;
      if (n1m1 < 0)     n1m1 = 0;
      if (n1m1 >= size) n1m1 = size-1;
      if (n1 < 0)       n1 = 0;
      if (n1 >= size)   n1 = size-1;
      if (n1p1 < 0)     n1p1 = 0;
      if (n1p1 >= size) n1p1 = size-1;
      if (n1p2 < 0)     n1p2 = 0;
      if (n1p2 >= size) n1p2 = size-1;
    
      if (n2m2 < 0)     n2m2 = 0;
      if (n2m2 >= size) n2m2 = size-1;
      if (n2m1 < 0)     n2m1 = 0;
      if (n2m1 >= size) n2m1 = size-1;
      if (n2 < 0)       n2 = 0;
      if (n2 >= size)   n2 = size-1;
      if (n2p1 < 0)     n2p1 = 0;
      if (n2p1 >= size) n2p1 = size-1;
      if (n2p2 < 0)     n2p2 = 0;
      if (n2p2 >= size) n2p2 = size-1;

      /* A is the TKEO on the image */
      A[k] = f[n1 + n2*size] * f[n1 + n2*size]
           - (f[n1m1 + n2*size] * f[n1p1 + n2*size])
           - (f[n1 + n2m1*size] * f[n1 + n2p1*size]);

      /* B is TKEO on (f shift left - f shift right) */
      B[k] = (2 * (f[n1p1 + n2*size] - f[n1m1 + n2*size]) 
             * (f[n1p1 + n2*size] - f[n1m1 + n2*size]))
           -  ((f[n1 + n2*size] - f[n1m2 + n2*size])
             * (f[n1p2 + n2*size] - f[n1 + n2*size]))
           -  ((f[n1p1 + n2m1*size] - f[n1m1 + n2m1*size])
             * (f[n1p1 + n2p1*size] - f[n1m1 + n2p1*size]));

      /* C is TKEO on (f shift up - f shift down) */
      C[k] = (2 * (f[n1 + n2p1*size] - f[n1 + n2m1*size])
             * (f[n1 + n2p1*size] - f[n1 + n2m1*size]))
           -  ((f[n1m1 + n2p1*size] - f[n1m1 + n2m1*size])
             * (f[n1p1 + n2p1*size] - f[n1p1 + n2m1*size]))
           -  ((f[n1 + n2*size] - f[n1 + n2m2*size])
             * (f[n1 + n2p2*size] - f[n1 + n2*size]));

      /* Check and see if ESA can be evaluated */
      if (A[k] <= (float)0.0) Afail++;
      if (B[k] <  (float)0.0) Bfail++;
      if (C[k] <  (float)0.0) Cfail++;
      if (B[k]+C[k] <= (float)0.0) BpCfail++;

      if (  (A[k]   >  (float)0.0) &&
            (B[k]   >= (float)0.0) &&
            (C[k]   >= (float)0.0) &&
            (B[k]+C[k] >  (float)0.0) ) {  /* then the ESA is ok at this pix */

        GoodCount++;
        GOOD = 1;

        /* compute unsigned frequency estimates in radians */
        Usin = pow((double)0.25*(double)B[k]/(double)A[k], (double)0.5);
        if (Usin > (double)1.0)  Usin = (double)1.0;
        if (Usin < (double)-1.0) Usin = (double)-1.0;
        Uhat[k] = (float)asin(Usin);
        if (Uhat[k] > (float)M_PI_2) Uhat[k] = (float)M_PI_2;
        if (Uhat[k] < (float)0.0)    Uhat[k] = (float)0.0;
        Vsin = pow((double)0.25*(double)C[k]/(double)A[k], (double)0.5);
        if (Vsin > (double)1.0)  Vsin = (double)1.0;
        if (Vsin < (double)-1.0) Vsin = (double)-1.0;
        Vhat[k] = (float)asin(Vsin);
        if (Vhat[k] > (float)M_PI_2) Vhat[k] = (float)M_PI_2;
        if (Vhat[k] < (float)0.0)    Vhat[k] = (float)0.0;

        /* correct relative signs of frequency estimates and convert to cps */
        if (((G->u0 < (double)0.0) && (G->v0 > (double)0.0)) ||
           ((G->u0 > (double)0.0) && (G->v0 < (double)0.0))) {
          Vhat[k] *= (float)-1.0;
        }

      } /* if ESA ok at this pix */
    }   /* for col */
  }     /* for row */

  Smooth = fmedNxN(Uhat,size,MEDSIZE,0,0,size-1,size-1);
  free(Uhat);
  Uhat = Smooth;
  Smooth = fmedNxN(Vhat,size,MEDSIZE,0,0,size-1,size-1);
  free(Vhat);
  Vhat = Smooth;

  /* compute amplitudes with smoothed frequencies */
  for (row=0; row < X->size; row++) {
    for (col=0; col < X->size; col++) {

        k = row*size + col;

        if (Uhat[k] > (float)M_PI_2)  Uhat[k] = (float)M_PI_2;
        if (Uhat[k] < (float)0.0)     Uhat[k] = (float)0.0;
        if (Vhat[k] > (float)M_PI_2)  Vhat[k] = (float)M_PI_2;
        if (Vhat[k] < (float)-M_PI_2) Vhat[k] = (float)-M_PI_2;
        Ucps = ((float)0.5 * Uhat[k]) / (float)M_PI;
        Vcps = ((float)0.5 * Vhat[k]) / (float)M_PI;

        /* compute smoothed amplitude estimate */
        FilterMag = G_EvalMag(G,(double)Ucps,(double)Vcps);
        Adenom = FilterMag * (float)pow(
                            sin((double)Uhat[k])*sin((double)Uhat[k])
                             + sin((double)Vhat[k])*sin((double)Vhat[k]),
                                (double)0.5);
        if (Adenom < (float)0.01) {
          Ahat[k] = Gamma = (float)0.0;
          A_VALID_FLAG = 0;
        } else {
          Ahat[k] = (float)pow((double)A[k],(double)0.5) / Adenom;
          A_VALID_FLAG = 1;
        }
    }   /* for col */
  }     /* for row */

  Smooth = fmedNxN(Ahat,size,MEDSIZE,0,0,size-1,size-1);
  free(Ahat);
  Ahat = Smooth;

  /* Now see if we have the dominant component */
  for (row=0; row < X->size; row++) {
    for (col=0; col < X->size; col++) {

        k = row*size + col;

        Ucps = ((float)0.5 * Uhat[k]) / (float)M_PI;
        Vcps = ((float)0.5 * Vhat[k]) / (float)M_PI;
        FilterMag = G_EvalMag(G,(double)Ucps,(double)Vcps);
        if (FilterMag < (float)0.01) {
          Gamma = (float)0.0;
          A_VALID_FLAG = 0;
        } else {
          A_VALID_FLAG = 1;
          Gamma = (Ahat[k]*Ahat[k]*FilterMag*FilterMag) / (G->GMax*G->GMax);
        }

        /* if best yet seen, record values and do housekeeping */
        if (Gamma > criterion[k]) {
          Winners++;
          WINNER = 1;
          criterion[k] = Gamma;
          maxfilt[k] = G->index;
          u[k] = Ucps;
          v[k] = Vcps;
          a[k] = Ahat[k];
          a_valid[k] = A_VALID_FLAG;
          u_valid[k] = v_valid[k] = 1;
          if (!A_VALID_FLAG) BadA++;
          if ((!(row % ReconInterval)) && (!(col % ReconInterval))) {
            if (!A_VALID_FLAG) {
              Theta[k] = (double)0.0;
            } else {
              CosTheta = (double)f[k]/(double)a[k];
              if (CosTheta > (double)1.0)  CosTheta = (double)1.0;
              if (CosTheta < (double)-1.0) CosTheta = (double)-1.0;
              Theta[k] = acos(CosTheta);
            }
          }
        }      /* if Gamma > criterion */
    }   /* for col */
  }     /* for row */

  free(Ahat);
  free(Uhat);
  free(Vhat);
  free(A);
  free(B);
  free(C);
  printf(" Afail=%d;Bfail=%d;Cfail=%d;BpCfail=%d;GoodCount=%d",
            Afail,Bfail,Cfail,BpCfail,GoodCount);
  printf("\n     Winners=%d;BadA=%d",Winners,BadA);
  return;

} /*----------------------------------------- dom_esa -----------------------*/

/*
 * AllocArrays
 *
 *  Allocate Working Arrays.
 */

void AllocArrays(argv,n,PrintChannels,PostFilter,a_valid,u_valid,v_valid,
                 maxfilt,criterion,A,U,V,Asm,Usm,Vsm,a_validFake,u_validFake,
                 v_validFake,maxfiltFake,criterionFake,AFake,UFake,VFake,Theta,
                 ThetaFake)

  char              *argv[];         /* argument list from command line */
  int                n;              /* size * size again */
  int                PrintChannels;  /* 1=print A,U est. from each channel */
  int                PostFilter;     /* 1=perform postfiltering */
  BYTE             **a_valid;        /* 1 where the a estimate is valid */
  BYTE             **u_valid;        /* 1 where the u estimate is valid */
  BYTE             **v_valid;        /* 1 where the v estimate is valid */
  int              **maxfilt;        /* Which channel max'd criterion at i,j */
  float            **criterion;      /* filter selection criterion */
  float            **A;              /* A estimates accross all filters */
  float            **U;              /* U estimates accross all filters */
  float            **V;              /* V estimates accross all filters */
  float            **Asm;            /* smoothed A estimates */
  float            **Usm;            /* smoothed U estimates */
  float            **Vsm;            /* smoothed V estimates */
  BYTE             **a_validFake;    /* 1 where fake a estimate is valid */
  BYTE             **u_validFake;    /* 1 where fake u estimate is valid */
  BYTE             **v_validFake;    /* 1 where fake v estimate is valid */
  int              **maxfiltFake;    /* fake maxfilt data */
  float            **criterionFake;  /* fake filter selection criterion */
  float            **AFake;          /* A est from a single channel */
  float            **UFake;          /* U est from a single channel */
  float            **VFake;          /* V est from a single channel */
  double           **Theta;          /* boundary condition interval for recon */
  double           **ThetaFake;      /* Fake boundary cond interval for recon */
{
 
  int                i;              /* loop counter */
 
 /*
  * Allocate working arrays
  */
  if ((*a_valid = (BYTE *) malloc(n * sizeof(BYTE))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
  if ((*u_valid = (BYTE *) malloc(n * sizeof(BYTE))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
  if ((*v_valid = (BYTE *) malloc(n * sizeof(BYTE))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
  for (i=0; i < n; i++) (*a_valid)[i] = (*u_valid)[i] = (*v_valid)[i] = 0;
  if ((*maxfilt = (int *)malloc(n * sizeof(int))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
  for (i=0; i < n; i++) (*maxfilt)[i] = -1;
  if ((*criterion = (float *)malloc(n * sizeof(float))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
  for (i=0; i < n; i++) (*criterion)[i] = (float)-1.0;
  if ((*A = (float *)malloc(n * sizeof(float))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
  if ((*U = (float *)malloc(n * sizeof(float))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
  if ((*V = (float *)malloc(n * sizeof(float))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
  if (PostFilter) {
    if ((*Asm = (float *)malloc(n * sizeof(float))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
    if ((*Usm = (float *)malloc(n * sizeof(float))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
    if ((*Vsm = (float *)malloc(n * sizeof(float))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
  }
  if ((*Theta = (double *)malloc(n * sizeof(double))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
  if ((*ThetaFake = (double *)malloc(n * sizeof(double))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
 
  if (PrintChannels || PostFilter) {
    if ((*a_validFake = (BYTE *) malloc(n * sizeof(BYTE))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
    if ((*u_validFake = (BYTE *) malloc(n * sizeof(BYTE))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
    if ((*v_validFake = (BYTE *) malloc(n * sizeof(BYTE))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
    if ((*maxfiltFake = (int *)malloc(n * sizeof(int))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
    for (i=0; i < n; i++) (*maxfiltFake)[i] = -1;
    if ((*criterionFake = (float *)malloc(n * sizeof(float))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
    for (i=0; i < n; i++) (*criterionFake)[i] = (float)-1.0;
    if ((*AFake = (float *)malloc(n * sizeof(float))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
    if ((*UFake = (float *)malloc(n * sizeof(float))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
    if ((*VFake = (float *)malloc(n * sizeof(float))) == NULL) {
      printf("\n%s: free store exhausted.\n",argv[0]);
      exit(-1);
    }
  }
 
  return;
} /*---------------------  AllocArrays  --------------------------------------*/
 
/*
 * DomRecon
 *
 *  Reconstruct the dominant component.
 *
 */
 
void DomRecon(a,u,v,size,pDomCompR,pDomCompI,ReconInterval,Theta)
 
  int             size;           /* length of signal for reconstruction */
  float          *a;              /* a estimates */
  float          *u;              /* u estimates */
  float          *v;              /* v estimates */
  float         **pDomCompR;      /* Real part of the dominant component */
  float         **pDomCompI;      /* Imag part of the dominant component */
  int             ReconInterval;  /* boundary condition interval for recon */
  double         *Theta;          /* phase initial conditions for recon */
{
 
  int             row;            /* loop counter for image rows */
  int             col;            /* loop counter for image cols */
  int             ROW;            /* row counter for recon blocks */
  int             COL;            /* col counter for recon blocks */
  int             R,C;            /* counters for rows and cols within block */
  int             k;              /* counter */
  double         *phase;          /* instantaneous phase */

 /*
  * Allocate arrays
  */
  if ((*pDomCompR = (float *)malloc(size*size*sizeof(float))) == NULL) {
    printf("\nDomRecon:  free store exhausted.\n");
    exit(-1);
  }
  if ((*pDomCompI = (float *)malloc(size*size*sizeof(float))) == NULL) {
    printf("\nDomRecon:  free store exhausted.\n");
    exit(-1);
  }
  if ((phase = (double *)malloc(size*size*sizeof(double))) == NULL) {
    printf("\nDomRecon:  free store exhausted.\n");
    exit(-1);
  }
 
 /*
  * Outer loops set top left corner of each reconsructed block
  */
  for (ROW=0; ROW < size; ROW+=ReconInterval) {
    for (COL=0; COL < size; COL+=ReconInterval) {
     /*
      * Reconstruct phase on first row of block
      */
      k = ROW*size + COL;
      phase[k] = Theta[k];
      for (k++,C=1,col=COL+1; (col < size) && (C < ReconInterval); 
           col++,C++,k++) {
        phase[k] = phase[k-1] + (double)2.0 * (double)M_PI * (double)u[k-1];
      }
     /*
      * Reconstruct phase on first col of block
      */
      for (k=(ROW+1)*size+COL,R=1,row=ROW+1; 
           (row < size) && (R < ReconInterval);
           row++,R++,k+=size) {
        phase[k] = phase[k-size] + (double)2.0 * (double)M_PI 
                                               * (double)v[k-size];
      }
     /*
      * Reconstruct phase at interior points in the block
      */
      for (R=1,row=ROW+1; (row < size) && (R < ReconInterval); R++,row++) {
        for (C=1,col=COL+1; (col < size) && (C < ReconInterval); C++,col++) {
          /* here here here */
          if (row==30 && col == 90) {
            col=90;
          }
          k = row*size + col;
          phase[k] = (double)0.5 * (phase[k-1] + phase[k-size] 
                     + (double)2.0 * (double)M_PI 
                       * ((double)u[k-1] + (double)v[k-size]));
        }
      }
    }    /* COL */
  }      /* ROW */

 /*
  * Reconstruct image values
  */
  for (k=row=0; row < size; row++) {
    for (col=0; col < size; col++,k++) {
      (*pDomCompR)[k] = a[k] * (float)cos(phase[k]);
      (*pDomCompI)[k] = a[k] * (float)sin(phase[k]);
    }
  }
  free(phase);
  return;
} /*----------------------------------------- DomRecon ----------------------*/

/*
 * InsertAsm
 *
 *   Insert smoothed amplitude estimates from channel into the dominant
 *   component amplitude estimate array.
 *
 *
 */
 
void InsertAsm(Asm,A,maxfilt,size,idx)
 
  float          *Asm;            /* smoothed amplitude estimtes */
  float          *A;              /* dominant component amplitude estimates */
  int            *maxfilt;        /* Which channel max'd criterion at i,j */
  int             size;           /* length of signal */
  int             idx;            /* index of channel being processed */
{
 
  int             i;              /* loop counters for image coordinates */
  int             n;              /* size * size */
 
  n = size * size;
  for (i=0; i < n; i++) {
    if (maxfilt[i] == idx) {
      A[i] = Asm[i];
    }
  }
 
  return;
} /*----------------------------------------- InsertAsm ---------------------*/
#endif
