/*
 * FreeWAb.c
 *
 *   free working arrays for trackb.c
 *
 * 3/15/96 jph
 */

#ifndef FREEWAB_C
#define FREEWAB_C

#include "track.h"
 
void FreeWAb(KA,KU,KV,Aob,Uob,Vob,Alast,Ulast,Vlast,ChannelStatus,Qorder,
             ChannelQ,ChanQcopy,LastStart)

  pABgain      *KU;             /* gains for A tracker */
  pABgain      *KV;             /* gains for U tracker */
  pABgain      *KA;             /* gains for V tracker */
  float       **Aob;            /* row of observations of A */
  float       **Uob;            /* row of observations of u */
  float       **Vob;            /* row of observations of v */
  float       **Alast;          /* last row of observations of A */
  float       **Ulast;          /* last row of observations of u */
  float       **Vlast;          /* last row of observations of v */
  int         **ChannelStatus;  /* track assoc status of channel */
  int         **Qorder;         /* no.s of channels sorted by Q */
  float       **ChannelQ;       /* channel quality */
  float       **ChanQcopy;      /* copy of channel quality for sorting */
  image_point **LastStart;      /* for each chan, pix of last trackstart */
{

 /*
  * Free Working Arrays
  */
  *KA = KillABgain(*KA);
  *KU = KillABgain(*KU);
  *KV = KillABgain(*KV);
  free(*Aob);
  free(*Uob);
  free(*Vob);
  free(*Alast);
  free(*Ulast);
  free(*Vlast);
  free(*ChannelStatus);
  free(*Qorder);
  free(*ChannelQ);
  free(*ChanQcopy);
  free(*LastStart);

  *Aob = *Uob = *Vob = *Alast = *Ulast = *Vlast = *ChannelQ = *ChanQcopy 
       = (float *)NULL;

  *ChannelStatus = *Qorder = (int *) NULL;

  *LastStart = (image_point *)NULL;
  return;
}/*--------------------------------------------  FreeWAb  --------------------*/
#endif
