/*
 * Kidx.c
 *
 *   Return an index into a Kalman gain sequence.  The first argument is
 *   the desired gain.  If it is not passed the end of the gain sequence,
 *   then it is returned.  Otherwise, the index of the requested gain
 *   is beyond the point where the gain sequence converged, and the index
 *   of the last gain in the sequence is returned.
 *
 * 2/23/96 jph
 */

#ifndef KIDX_C
#define KIDX_C

#include "track.h"
 
int Kidx(k,K)

  int          k;               /* index of the desired gain */
  pKgain       K;               /* gain sequence */
{

  if (k < K->Ngains) {
    return(k);
  } else {
    return(K->Ngains-1);
  }
}/*--------------------------------------------  Kidx  ----------------------*/
#endif
