/*
 * KillABgain.c
 *
 *   Deallocate a Kalman gain sequence for an Alpha-Beta filter.
 *   A null pointer is returned to facilitate calls of the form
 *     K = KillABgain(K);
 *
 * 3/15/96 jph
 */

#ifndef KILLABGAIN_C
#define KILLABGAIN_C

#include "track.h"
 
pABgain KillABgain(K)

  pABgain      K;               /* Alpha-Beta filter gains */
{
 
  if (K != NULL) {
    if (K->alpha != NULL) {
      if (K->alpha->gain != NULL) {
        free(K->alpha->gain);
      }
      free(K->alpha);
    }
    if (K->beta != NULL) {
      if (K->beta->gain != NULL) {
        free(K->beta->gain);
      }
      free(K->beta);
    }
    free(K);
  }
  return((pABgain)NULL);
}/*--------------------------------------------  KillABgain  ----------------*/
#endif
