/*
 * KillTrack.c
 *
 *   Kill a track
 *
 * 4/25/94 jph
 */

#ifndef KILLTRACK_C
#define KILLTRACK_C

#include "track.h"
 
/*-----------------------------------------------------------------------------
   KILL TRACK
-----------------------------------------------------------------------------*/

void KillTrack(T,size)
 
  trackP  T;                    /* Track to be Killed */
 
{
 
  int     k;                    /* counter */

  if (T->protect) return;
  T->in_use = 0;
  T->candidate = 0;
  T->active = 0;
  T->updated = 0;
  T->coast = 0;
  T->Ncoast = 0;
  T->TotNcoast = 0;
  T->dormant = 0;
  T->Ndormant = 0;
  T->dormantOnRow = 0;
  T->NRowsDormant = 0;
  T->age = 0;
  T->NgoodUpd = 0;
  T->NgoodUpdRow = 0;
  if (T->HorUpd != NULL) {
    T->HorUpd->k = 0;
  }
  for (k=0; k < MAXNTRACK; k++) {
    T->MergeCount[k] = 0;
    T->MergeRows[k] = 0;
  }
  T->MaxQual = (float)0.0;
  T->AveQualRow = (float)0.0;
  T->AveChanQual = (float)0.0;
  T->SumInnov = (float)0.0;
  T->Hist.Start.row = 0;
  T->Hist.Start.col = 0;
  T->Hist.Stop.row = 0;
  T->Hist.Stop.col = 0;
  T->Hist.Merged    = 0;
  T->Hist.CandidateWhenMerged = 0;
  T->Hist.MTrack    =-1;
  T->Hist.SmallAmpDeac = 0;
  T->Hist.NRaysVis = 0;
  if (T->Hist.RaysVis != NULL) free(T->Hist.RaysVis);
  if (T->A_filt  != NULL) free(T->A_filt);
  if (T->U_filt  != NULL) free(T->U_filt);
  if (T->V_filt  != NULL) free(T->V_filt);
  if (T->ObsChan != NULL) free(T->ObsChan);
  if (T->HorUpd  != NULL) free(T->HorUpd);
  for (k=0; k < size; k++) {
    if (T->VertUpd[k] != NULL) free(T->VertUpd[k]);
    if (T->NextVertUpd[k] != NULL) free(T->NextVertUpd[k]);
  }
  free(T->VertUpd);
  free(T->NextVertUpd);
  T->Upd = NULL;
  return;
 
}/*--------------------------------------------  KillTrack  ------------------*/
#endif
