/*
 * ReadNextRowObservations
 *
 *  Set Alast to the current row of A observations and read another row
 *  from the file into Aob.  Similarly for U and V.
 *
 *  4/25/94 jph
 */

#ifndef RDNXTROW_C
#define RDNXTROW_C

#include "track.h"

/*-----------------------------------------------------------------------------
   READ NEXT ROW OBSERVATIONS
-----------------------------------------------------------------------------*/

void ReadNextRowObservations(cmd,Aob,Uob,Vob,Alast,Ulast,Vlast,fdA,fdU,fdV,
                             ReadSize)

  char    *cmd;                  /* argv[0] */
  float  **Aob;                  /* row of observations of A */
  float  **Uob;                  /* row of observations of u */
  float  **Vob;                  /* row of observations of v */
  float  **Alast;                /* last row of observations of A */
  float  **Ulast;                /* last row of observations of u */
  float  **Vlast;                /* last row of observations of v */
  int      fdA;                  /* file descriptor for A obs file */
  int      fdU;                  /* file descriptor for U obs file */
  int      fdV;                  /* file descriptor for V obs file */
  int      ReadSize;             /* size of a row of obs for A,U, or V */
{
 
  float *temp;                  /* temporary pointer for doing switch */

  temp   = *Aob;
  *Aob   = *Alast;
  *Alast = temp;
  if (read(fdA,*Aob,ReadSize) != ReadSize) {
    printf("\n%s: Complete read of A obs file did not succeed.\n",cmd);
    exit(-1);
  }

  temp   = *Uob;
  *Uob   = *Ulast;
  *Ulast = temp;
  if (read(fdU,*Uob,ReadSize) != ReadSize) {
    printf("\n%s: Complete read of U obs file did not succeed.\n",cmd);
    exit(-1);
  }

  temp   = *Vob;
  *Vob   = *Vlast;
  *Vlast = temp;
  if (read(fdV,*Vob,ReadSize) != ReadSize) {
    printf("\n%s: Complete read of V obs file did not succeed.\n",cmd);
    exit(-1);
  }

  return;
 
}/*--------------------------------------------  ReadNextRowObservations  ---*/
#endif
