
/*
 * ResizeWrite.c
 *
 *   Resize a square image that has been zero padded and/or reflected, and 
 *   write it out to disk.
 *
 * 11/7/95 jph
 */

#ifndef RESIZEWRITE_C
#define RESIZEWRITE_C

#include "track.h"
 
void ResizeWrite(X,ZeroPad,Rfn,Ifn)

  int                ZeroPad;        /* 1 if zero padding is to be used */
  pFloatImage        X;              /* Image to be resized and written */
  char              *Rfn;            /* Filename for real part of image */
  char              *Ifn;            /* Filename for imag part of image */
{
 
  int                row;            /* image row counter */
  pFloatImage        Y;              /* resized image */

  Y = (pFloatImage)malloc(sizeof(FloatImage));
  Y->square = X->square;
 /*
  * resize image if necessary
  */
  if (ZeroPad) {
    Y->size = X->size >> 1;
    Y->rows = X->rows >> 1;
    Y->cols = X->cols >> 1;
  } else {
    Y->size = X->size;
    Y->rows = X->rows;
    Y->cols = X->cols;
  }
  Y->Real = (float *)malloc(Y->size*Y->size*sizeof(float));
  Y->Imag = (float *)malloc(Y->size*Y->size*sizeof(float));
  Y->FFTReal = (float *)malloc(Y->size*Y->size*sizeof(float));
  Y->FFTImag = (float *)malloc(Y->size*Y->size*sizeof(float));

 /*
  * Copy image data from X
  */
  for (row=0; row < Y->size; row++) {
    memcpy(Y->Real+row*Y->size,X->Real+row*X->size,Y->size*sizeof(float));
    memcpy(Y->Imag+row*Y->size,X->Imag+row*X->size,Y->size*sizeof(float));
    memcpy(Y->FFTReal+row*Y->size,X->FFTReal+row*X->size,Y->size*sizeof(float));
    memcpy(Y->FFTImag+row*Y->size,X->FFTImag+row*X->size,Y->size*sizeof(float));
  }

 /*
  * Write Image to disk
  */
  if (strcmp(Rfn,"none")) {
    f2disk(Y->Real,Y->size,Y->size,Rfn);
  }
  if (strcmp(Ifn,"none")) {
    f2disk(Y->Imag,Y->size,Y->size,Ifn);
  }

 /*
  * Free allocated memory
  */
  Y = KillFloat(Y);

  return;

}/*------------------------------------  ResizeWrite   ----------------------*/
#endif
