
/*
 * addcomps1D.c
 *
 *   reads in the components of a 1D multicomponent AM-FM signal and
 *   adds them together to construct the multicomponent signal.
 *
 *  jph  10/16/94
 *
 */

#ifndef ADDCOMPS1D_C
#define ADDCOMPS1D_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{

  float *x;                /* image to be read */
  float *y;                /* output image */
  int    fd;               /* file descriptor */
  int    size;             /* row , col dim */
  int    Ncomps;           /* Number of components in the signal */
  int    i;                /* loop counter */
  int    k;                /* loop counter */
  int    comp;             /* component currently being processed */
 
 /*
  * If no arguments given, print usage message
  */
  if (argc ==  1) {
    printf("\n\n%s: add components to construct multicomponent 1D signal",
           argv[0]);
    printf("\nusage: %s size infile1 infile2 [infile3...] outfile \n",argv[0]);
    return;
  }

 /*
  * Allocate workspace
  */
  size = atoi(argv[1]);
  Ncomps = argc - 3;
  printf("\n%s: Assuming %d components.\n",argv[0],Ncomps);
  x = (float *)malloc(size * sizeof(float));
  y = (float *)malloc(size * sizeof(float));
  for (i=0; i < size; i++) {
    y[i] = (float) 0.0;
  }
  
 /*
  * Read each component and add it to the composite signal
  */
  for (k=2,comp=0; comp < Ncomps; comp++,k++) {
    disk2f(x,1,size,argv[k]);
    for (i=0; i < size; i++) {
      y[i] += x[i];
    }
  }

 /*
  * Write out the composite signal
  */
  f2disk(y,1,size,argv[k]);

  return;
} 
#endif
