
/*
 * bExblock.c
 *
 *  extract subimage from a BYTE image
 *
 */

#ifndef BEXBLOCK_C
#define BEXBLOCK_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  BYTE        *x;            /* input image */
  BYTE        *y;            /* output image */
  int          size;         /* row , col dim */
  int          N;            /* size * size */
  int          ulx;          /* col of upper left corner of subimage */
  int          uly;          /* row of upper left corner of subimage */
  int          lrx;          /* col of lower right corner of subimage */
  int          lry;          /* row of lower right corner of subimage */
  int          row,col;      /* loop counter */
  int          i;            /* counter */
  int          yrows;        /* num rows in y */
  int          ycols;        /* num cols in y */
 
  if (argc !=  8) {
    printf("\n\n%s: extract subimage from BYTE image.",argv[0]);
    printf("\nusage: %s size infile ulx uly lrx lry outfile \n",argv[0]);
    return;
  }

  size = atoi(argv[1]);
  N     = size * size; 
  ulx   = atoi(argv[3]);
  uly   = atoi(argv[4]);
  lrx   = atoi(argv[5]);
  lry   = atoi(argv[6]);

  yrows = lry - uly + 1;
  ycols = lrx - ulx + 1;

  x = (BYTE *) malloc(size*size*sizeof(BYTE));
  y = (BYTE *) malloc(yrows*ycols*sizeof(BYTE));
  disk2byte(x,size,size,argv[2]);
  
  for (i=0,row=uly; row <= lry; row++) {
    for (col=ulx; col <= lrx; col++,i++) {
      y[i] = x[row*size + col];
    }
  }
  byte2disk(y,yrows,ycols,argv[7]);

  return;
} 
#endif
