/*
 * binarize: 
 *   
 *   read in a gray scale image.  turn it into a binary image in the following way:
 *   find the median.  pixels greater than or equal to the median get value all ones; 
 *   pixels less than the median get value all zeros.
 *
 */

#include <stdio.h>

#include "teager2D.h"


main(argc,argv) 

  int     argc;
  char   *argv[];
{

  double sigma;                 /* std dev of data */
  double mean;                  /* mean of image data */
  BYTE   min,max;               /* min & max image values */
  BYTE  med;                    /* median of image */
  int i;                        /* counters */
  int SIZE;                     /* you know what this is , dummy */
  BYTE *x,*y;                   /* input and output images */

  printf("\n%s: program converts a grey level image to a binary image.",
                argv[0]);
 /*
  * Check for proper invocation
  */  
  if (argc != 4) {
    printf("\nUsage: %s size infile outfile\n",argv[0]);
    exit(0);
  }
  SIZE = atoi(argv[1]);

 /*
  * Allocate image arrays
  */
  if ((x = (BYTE *)malloc(SIZE*SIZE*sizeof(BYTE))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }
  if ((y = (BYTE *)malloc(SIZE*SIZE*sizeof(BYTE))) == NULL) {
    printf("\n%s: free store exhausted.\n",argv[0]);
    exit(-1);
  }

 /*
  * Read the input image
  */
  disk2byte(x,SIZE,SIZE,argv[2]);

 /*
  * Find the median of the input image by histogram method
  */
  sstat(x,SIZE,SIZE,&min,&med,&max,&mean,&sigma);
printf("\nMedian=%d.\n",med);

 /*
  * Make output image by thresholding input image at its median
  */
  for (i=0; i<SIZE*SIZE; i++) {
    if ((double)x[i] < med) {
      y[i] = 0x00;
    }
    else {
      y[i] = 0xff;
    }
  }

 /*
  * Write the output image
  */
  byte2disk(y,SIZE,SIZE,argv[3]);

  return;
}
