/*
 * bmed3x3.c 
 *
 *   do a 3x3 median filter on a BYTE image
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  BYTE  * x;             /* input */
  BYTE  * y;             /* output image */
  BYTE    X[9];          /* neighborhood */
  BYTE    Xtemp;         /* temp floating variable */
  int     size;          /* row , col dim */
  int     k;             /* loop counter */
  int     i;             /* loop counter */
  int     j;             /* loop counter */
  int     row,col;       /* loop counters */
  int     row1,row2,col1,col2;   /* limits of where to run filter */

  if (argc != 8) {
    printf("\n\n%s: median filter a BYTE image.",argv[0]);
    printf("\nusage: %s size row1 col1 row2 col2 infile outfile \n",argv[0]);
    exit(0);
  }

  size = atoi(argv[1]);
  row1 = atoi(argv[2]);
  col1 = atoi(argv[3]);
  row2 = atoi(argv[4]);
  col2 = atoi(argv[5]);
  x    = (BYTE*) malloc(size*size*sizeof(BYTE));
  y    = (BYTE*) malloc(size*size*sizeof(BYTE));
  disk2byte(x,size,size,argv[6]);
  for (k=0; k < size*size; k++) {
    y[k] = x[k];
  }
  for (row=row1; row <=row2; row++) {
    for (col=col1; col <= col2; col++) {
      k = row*size+col;
      X[0] = x[k-size-1];       
      X[1] = x[k-size];       
      X[2] = x[k-size+1];       
      X[3] = x[k-1];       
      X[4] = x[k];       
      X[5] = x[k+1];       
      X[6] = x[k+size-1];       
      X[7] = x[k+size];       
      X[8] = x[k+size+1];       
      for (i=0; i < 5; i++) {
        for (j=i+1; j < 9; j++) {
          if (X[j] > X[i]) {
            Xtemp = X[j];
            X[j]  = X[i];
            X[i]  = Xtemp;
          }
        }
      }
      y[k] = X[4];
    }
  }

  byte2disk(y,size,size,argv[7]);

  return;
}
