
/*
 * bsetblock.c
 *
 *  set a block of pixels in a BYTE image to a specified value
 *
 */

#ifndef BSETBLOCK_C
#define BSETBLOCK_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  BYTE        *x;            /* input image */
  int          fd;           /* file descriptor */
  int          size;         /* row , col dim */
  int          ulx;          /* col of upper left corner of block */
  int          uly;          /* row of upper left corner of block */
  int          lrx;          /* col of lower right corner of block */
  int          lry;          /* row of lower right corner of block */
  BYTE         xx;           /* value for block pixels */
  int          row,col;      /* loop counter */

  if (argc !=  9) {
    printf("\n\n%s: set a block of pixels to bvalue in BYTE image.",argv[0]);
    printf("\nusage: %s infile size ulx uly lrx lry bvalue outfile \n",argv[0]);
    return;
  }

  size = atoi(argv[2]);
  ulx   = atoi(argv[3]);
  uly   = atoi(argv[4]);
  lrx   = atoi(argv[5]);
  lry   = atoi(argv[6]);
  xx   = (BYTE)atoi(argv[7]);

  x = (BYTE *) malloc(size*size*sizeof(BYTE));
  disk2byte(x,size,size,argv[1]);
  
  for (row=uly; row <= lry; row++) {
    for (col=ulx; col <= lrx; col++) {
      x[row*size + col] = xx;
    }
  }
  byte2disk(x,size,size,argv[8]);

  return;
} 
#endif
