
/*
 * bsetborder.c
 *
 *  set the border of a BYTE image to a specified value
 *
 */

#ifndef BSETBORDER_C
#define BSETBORDER_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  BYTE        *x;            /* input image */
  int          fd;           /* file descriptor */
  int          size;         /* row , col dim */
  int          x1;           /* x1,y1 defines upper left corner of image */
  int          y1;           /* x1,y1 defines upper left corner of image */
  int          x2;           /* x2,y2 defines lower right corner of image */
  int          y2;           /* x2,y2 defines lower right corner of image */
  BYTE         xx;           /* value for border pixels */
  int          row,col;      /* loop counter */

  if (argc !=  9) {
    printf("\n\n%s: Read a BYTE image; make a border with a set value",argv[0]);
    printf("\nusage: %s infile size x1 y1 x2 y2 value outfile \n",argv[0]);
    return;
  }

  size = atoi(argv[2]);
  x1   = atoi(argv[3]);
  y1   = atoi(argv[4]);
  x2   = atoi(argv[5]);
  y2   = atoi(argv[6]);
  xx   = (BYTE)atoi(argv[7]);

  x = (BYTE *) malloc(size*size*sizeof(BYTE));
  disk2byte(x,size,size,argv[1]);
  
  for (row=0; row < y1; row++) {
    for (col=0; col < size; col++) {
      x[row*size+col] = xx;
    }
  }
  for (row=y1; row < y2; row++) {
    for (col=0; col < x1; col++) {
      x[row*size+col] = xx;
    }
    for (col=x2; col < size; col++) {
      x[row*size+col] = xx;
    }
  }
  for (row=y2; row < size; row++) {
    for (col=0; col < size; col++) {
      x[row*size+col] = xx;
    }
  }
  byte2disk(x,size,size,argv[8]);

  return;
} 
#endif
