
/*
 * bstat.c
 *
 * display the statistics of a byte image
 *
 */

#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  BYTE  *x;                 /* input image  */
  int    size;             /* row , col dim */
  BYTE   min,med,max;
  double mean,sigma,sigmasq;
 
  if (argc !=  3) {
    printf("\n\n%s: compute statistics of a byte image.",argv[0]);
    printf("\nusage: %s size imagefile \n",argv[0]);
    return;
  }
  size = atoi(argv[1]);
  x = (BYTE *) malloc(size*size*sizeof(BYTE));
 
  disk2byte(x,size,size,argv[2]);
  sstat(x,size,size,&min,&med,&max,&mean,&sigma);
  sigmasq = sigma * sigma;
  printf("\n\nmax=%d  med=%d  min=%d  mean=%lf  stdev=%lf  var=%lf\n\n",
          max,med,min,mean,sigma,sigmasq);
  return;
} 
