/*
 * bstrip.c 
 *
 * strip header bytes off of a square binary image with one byte per pixel
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  int   size;       /* size of output image */
  int   stripsize;  /* number of bytes to strip */
  int   insize;     /* size of input image (including header) */
  BYTE *x;          /* input image */
  BYTE *y;          /* output image */
  int   i,j;        /* cursors */

  if (argc != 5) {
    printf("\n\n%s: strip header bytes from a byte image.",argv[0]);
    printf("\nusage: %s size stripsize infile outfile\n");
    exit(-1);
  }

  size = atoi(argv[1]);
  stripsize = atoi(argv[2]);
  insize = stripsize + size*size;
  x = (BYTE*) malloc(insize*sizeof(BYTE));
  y = (BYTE*) malloc(size*size*sizeof(BYTE));
  disk2byte(x,insize,1,argv[3]);

  for (i=stripsize,j=0; i < insize; i++,j++) {
    y[j] = x[i];
  }
  byte2disk(y,size,size,argv[4]);
  return;
}
