/*
 * circlemask.c 
 *
 * make a circular mask image.
 *
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  int   size;       /* size of output image */
  float radius;     /* radius of circle in pixels */
  float R;          /* radius of a pixel */
  BYTE *y;          /* output image */
  int   so2;        /* size / 2 */
  int   row;        /* image row */
  int   col;        /* image col */
  int   Row;        /* row - so2 */
  int   Col;        /* col - so2 */

  if (argc != 4) {
    printf("\n\n%s: make a circular mask image.",argv[0]);
    printf("\nusage: %s size radius outfile\n",argv[0]);
    exit(-1);
  }

  size = atoi(argv[1]);
  so2 = size >> 1;
  radius = atof(argv[2]);
  y = (BYTE*) malloc(size*size*sizeof(BYTE));

  for (row=0; row < size; row++) {
    for (col=0; col < size; col++) {
      Row = row-so2;
      Col = col-so2;
      R = (float)pow((double)(Row*Row + Col*Col),(double)0.5);
      if (R < radius) {
        y[row*size + col] = 255;
      } else {
        y[row*size + col] = 0;
      }
    }
  }

  byte2disk(y,size,size,argv[3]);
  return;
}
