/*
 * conv512to256.c
 *
 *  read a 512 square image and output a 256 square image.
 *
 *  20 July 1994 joe havlicek
 */

#include "teager2D.h"


main(argc,argv)

  int   argc;
  char *argv[];

{

 /*
  * local variable frame
  */
  int start_row, start_col;
  int filecount;
  int i,j,row,col;
  int src_row,src_col;
  float maxf, minf;
  float fact;
  int fd;
  unsigned char im512[512][512];
  unsigned char im256[256][256];
 
  if (argc != 3) {
    printf("\n%s: downsample a 512x512 image to 256x256.",argv[0]);
    printf("\nUsage: %s infile outfile.\n",argv[0]);
    exit(-1);
  }


  if ((fd = open(argv[1], O_RDONLY))==-1) {
     printf("\nCould Not Open File %s\n",argv[1]);
     exit(-1);
   }
   read(fd,im512,512*512*sizeof(unsigned char));
   close(fd);
   for (i=0; i<512; i+=2)
     for (j=0; j<512; j+=2)
      im256[i/2][j/2] = (im512[i][j]+im512[i][j+1]
                        +im512[i+1][j]+im512[i+1][j+1]) / 4.0;

   byte2disk(im256,256,256,argv[2]);
   exit(0);
}
