
/*
 * d2ascii.c
 *
 * converts double signal to ascii suitable for use with xvgr
 *
 */

#ifndef D2B_C
#define D2B_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  double * x;           /* signal to be read */
  float * fx;           /* signal converted to float */
  FILE *ofpin;          /* output file pointer */
  int i,j,ii,jj;        /* loop counters */
  int size;             /* row , col dim */
 
  if (argc !=  4) {
    printf("\n\nusage: d2b size infile outfile \n");
    return;
  }
  size = atoi(argv[1]);
  x = (double *) malloc(size*sizeof(double));
  fx = (float *) malloc(size*sizeof(float));
 
  disk2d(x,size,1,argv[2]);
  if ((ofpin = fopen(argv[3],"w")) == NULL) {
    printf("\nCannot open file %s",argv[3]);
    exit(0);
  }
  for (i=0; i<size; i++) {
    fx[i] = (float) x[i];
    fprintf(ofpin,"%d\t%f\n",i,fx[i]);
  }
  fclose(ofpin);
  return;
} 
#endif
