/*
 * diagmask.c 
 *
 * make a diamond mask image.
 *
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  int   size;       /* size of output image */
  int   diaglen;    /* length of a diagonal of the diamond */
  int   diagleno2;  /* diaglen / 2 */
  BYTE *y;          /* output image */
  int   so2;        /* size / 2 */
  int   row;        /* image row */
  int   col;        /* image col */
  int   i;          /* cursor */

  if (argc != 4) {
    printf("\n\n%s: make a diamond mask image.",argv[0]);
    printf("\nusage: %s size diaglen outfile\n");
    exit(-1);
  }

  size = atoi(argv[1]);
  so2 = size >> 1;
  diaglen = atoi(argv[2]);
  diagleno2 = diaglen >> 1;
  y = (BYTE*) malloc(size*size*sizeof(BYTE));

  for (i=0; i < size*size; i++) {
    y[i] = 0;
  }

  for (row=so2-diagleno2; row < so2; row ++) {
    for (col=size-row-diagleno2; col < so2; col++) {
      y[row*size+col] = 255;
    }
    y[row*size+so2] = 255;
    for (col=so2+1; col < row+diagleno2; col++) {
      y[row*size+col] = 255;
    }
  }
  for (row=so2,col=so2-diagleno2; col <= so2+diagleno2; col++) {
    y[row*size+col] = 255;
  }
  for (row=so2+1; row <= so2+diagleno2; row++) {
    for (col=so2+1; col <= size-row+diagleno2; col++) {
      y[row*size+col] = 255;
    }
    y[row*size+so2] = 255;
    for (col=row-diagleno2; col < so2; col++) {
      y[row*size+col] = 255;
    }
  }

  byte2disk(y,size,size,argv[3]);
  return;
}
