
/*
 * f128to256.c
 *
 *  convert a 128x128 float image to a 256x256 float image
 *
 */

#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float       *x;            /* input image */
  float       *y;            /* output image */
  int          xrow,xcol;    /* loop counter */
  int          yrow,ycol;    /* loop counter */
  int          i;            /* counter */
 
  if (argc !=  3) {
    printf("\n\n%s: convert 128x128 float image to 256x256.",argv[0]);
    printf("\nusage: %s infile outfile \n",argv[0]);
    return;
  }

  x = (float *) malloc(128*128*sizeof(float));
  y = (float *) malloc(256*256*sizeof(float));
  disk2f(x,128,128,argv[1]);
  
  for (xrow=yrow=0; xrow < 128; xrow++,yrow+=2) {
    for (xcol=ycol=0; xcol < 128; xcol++,ycol+=2) {
      y[yrow*256 + ycol] = y[(yrow+1)*256 + ycol]
                         = y[yrow*256 + ycol + 1]
                         = y[(yrow+1)*256 + ycol + 1]
                         = x[xrow*128 + xcol];
    }
  }

  f2disk(y,256,256,argv[2]);

  return;
} 
