
/*
 * f256to32.c
 *
 *  convert a 256x256 float image to a 32x32 float image
 *
 */

#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float       *x;            /* input image */
  float       *y;            /* output image */
  int          xrow,xcol;    /* loop counter */
  int          yrow,ycol;    /* loop counter */
  int          i;            /* counter */
 
  if (argc !=  3) {
    printf("\n\n%s: convert 256x256 float image to 32x32.",argv[0]);
    printf("\nusage: %s infile outfile \n",argv[0]);
    return;
  }

  x = (float *) malloc(256*256*sizeof(float));
  y = (float *) malloc(32*32*sizeof(float));
  disk2f(x,256,256,argv[1]);
  
  for (xrow=yrow=0; xrow < 256; yrow++,xrow+=8) {
    for (xcol=ycol=0; xcol < 256; ycol++,xcol+=8) {
      y[yrow*32+ycol] = x[xrow*256+xcol];
    }
  }

  f2disk(y,32,32,argv[2]);

  return;
} 
