
/*
 * f2bscale.c
 *
 * converts float image to byte with a specified gain.
 *
 */

#ifndef F2BSCALE_C
#define F2BSCALE_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float *x;             /* image to be read */
  float  gain;          /* gain factor */
  float  bias;          /* bias level */
  BYTE  *y;             /* output image */
  int    fd;            /* file descriptor */
  int    size;          /* row , col dim */
  int    i;             /* counter */
  int    N;             /* size * size */
 
  if (argc !=  6) {
    printf("\n\n%s: convert a float image to a byte image",argv[0]);
    printf("\nusage: %s size infile outfile gain bias\n",argv[0]);
    return;
  }

  size = atoi(argv[1]);
  gain = atof(argv[4]);
  bias = atof(argv[5]);

  N = size * size;
  x = (float *) malloc(size*size*sizeof(float));
  y = (BYTE *) malloc(size*size*sizeof(BYTE));
  disk2f(x,size,size,argv[2]);
 
  for (i=0; i < N; i++) {
    x[i] = gain * x[i] + bias;
    if (x[i] < (float)0.0) x[i] = (float)0.0;
    if (x[i] > (float)255.0) x[i] = (float)255.0;
    y[i] = (BYTE)x[i];
  }
  byte2disk(y,size,size,argv[3]);

  return;
} 
#endif
