
/*
 * f2short.c
 *
 * converts float signal to short suitable for use with 2au
 *
 */

#ifndef D2B_C
#define D2B_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float * fx;           /* signal converted to float */
  double * dx;          /* signal converted to double */
  unsigned char * bx;   /* signal converted to byte */
  short * sx;           /* signal converted to short */
  FILE *ofpin;          /* output file pointer */
  int i,j,ii,jj;        /* loop counters */
  int size;             /* row , col dim */
  int fd;               /* file descriptor */
  int n_bytes;          /* number of bytes to read */
 
  if (argc !=  4) {
    printf("\n\nusage: f2byte size infile outfile \n");
    return;
  }
  size = atoi(argv[1]);
  fx = (float *) malloc(size*sizeof(float));
  sx = (short *) malloc(size*sizeof(short));
 
  disk2f(fx,size,1,argv[2]);
  if ((ofpin = fopen(argv[3],"w")) == NULL) {
    printf("\nCannot open file %s",argv[3]);
    exit(0);
  }
  dx = f2d(fx,size,1);
  bx = d_dbx(dx,size,1);
  for (i=0; i<size; i++) sx[i] = bx[i];
  if ((fd = open(argv[3], O_WRONLY | O_CREAT, 0644))==-1) {
    printf("\nf2short.c : could not open file !");
    return;
  }
  n_bytes = size * sizeof(short);
  if (write(fd,sx,n_bytes) != n_bytes) {
    printf("\nf2short.c : complete disk write did not succeed.");
  }

  if (close(fd) == -1) printf("\nf2short.c : error in closing file.");
  return;
} 
#endif
