
/*
 * f2shscale.c
 *
 * converts float signal to short with a specified gain.
 *
 */

#ifndef F2SHSCALE_C
#define F2SHSCALE_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float *x;             /* signal to be read */
  float  gain;          /* gain factor */
  float  bias;          /* bias level */
  short *y;             /* output signal */
  int    fd;            /* file descriptor */
  int    size;          /* number of samples */
  int    i;             /* counter */
  int    N;             /* size  */
 
  if (argc !=  6) {
    printf("\n\n%s: convert a float signal to a short signal and scale",
           argv[0]);
    printf("\nusage: %s size infile outfile gain bias\n",argv[0]);
    return;
  }

  size = atoi(argv[1]);
  gain = atof(argv[4]);
  bias = atof(argv[5]);

  N = size;
  x = (float *) malloc(N*sizeof(float));
  y = (short *) malloc(N*sizeof(short));
  disk2f(x,size,1,argv[2]);
 
  for (i=0; i < N; i++) {
    x[i] = gain * x[i] + bias;
    y[i] = (short)x[i];
  }
  byte2disk(y,size,sizeof(short),argv[3]);

  return;
} 
#endif
