
/*
 * fClipHard.c
 *
 * Hard clip all image values.  If a pixel is greater than max, set it equal
 * to max.  If it is less than min, set it equal to min.
 *
 */

#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float  *x;                 /* input image  */
  int     size;              /* row , col dim */
  int     k;
  float   min,max;
 
  if (argc !=  6) {
    printf("\n\n%s: hard clip image values.",argv[0]);
    printf("\nusage: %s size infile min max outfile\n",argv[0]);
    return;
  }
  size = atoi(argv[1]);
  min = (float)atof(argv[3]);
  max = (float)atof(argv[4]);  

  x = (float *) malloc(size*size*sizeof(float));
  disk2f(x,size,size,argv[2]);

  for (k=0; k < size*size; k++) {
    if (x[k] < min) {
      x[k] = min;
    } else {
      if (x[k] > max) {
        x[k] = max;
      }
    }
  }

  f2disk(x,size,size,argv[5]);
  return;
} 
