/*
 * fExMiddle.c
 *
 *   get the center N/2 x N/2 subimage out of an N x N image and write it
 *   out to disk.
 * 
 *   2/9/95 jph
 *
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  float * x;             /* input */
  float * y;             /* output image */
  int     size;          /* row , col dim */
  int     so2;           /* size over 2 */
  int     so4;           /* size over 2 */
  int     k;             /* counter */
  int     j;             /* counter */
  int     row,col;       /* loop counters */
  int     yrow,ycol;     /* loop counters */

  if (argc != 4) {
    printf("\n\n%s: Extract size/2 square subimage from a float image.",
              argv[0]);
    printf("\nusage: %s infile size outfile \n",argv[0]);
    exit(0);
  }

  size = atoi(argv[2]);
  so2  = size >> 1;
  so4  = so2  >> 1;
  x    = (float*) malloc(size*size*sizeof(float));
  y    = (float*) malloc(so2*so2*sizeof(float));
  disk2f(x,size,size,argv[1]);

  for (yrow=0,row=so4; row < so2+so4; row++,yrow++) {
    for (ycol=0,col=so4; col < so2+so4; col++,ycol++) {
      k = row*size + col;
      j = yrow*so2 + ycol;
      y[j] = x[k];
    }
  }
  f2disk(y,so2,so2,argv[3]);

  return;
}
