
/*
 * fNorm.c
 *
 * Read real and imaginary images, output magnitude image.
 *
 */

#ifndef FNORM_C
#define FNORM_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{

  float  * xR;          /* real input  image */
  float  * xI;          /* imag input  image */
  float  * y;           /* output image */
  int fd;               /* file descriptor */
  int size;             /* row , col dim */
  int N;                /* num pixels in the image */
  int i;                /* loop counter */
 
  if (argc !=  5) {
    printf("\n\n%s: Read real and imaginary images, output magnitude image.",
           argv[0]);
    printf("\nusage: %s size RealFn ImagFn outfile \n",argv[0]);
    return;
  }

  size = atoi(argv[1]);
  N = size * size;
  xR = (float *) malloc(N*sizeof(float));
  xI = (float *) malloc(N*sizeof(float));
  y = (float *) malloc(N*sizeof(float));
  disk2f(xR,size,size,argv[2]);
  disk2f(xI,size,size,argv[3]);

  for (i=0; i < N; i++) {
    y[i] = (float)pow((double)(xR[i]*xR[i] + xI[i]*xI[i]),(double)0.5);
  }

  f2disk(y,size,size,argv[4]);

  return;
} 
#endif
