
/*
 * fSigClipHard.c
 *
 * Hard clip at "sigmas" sigmas above the mean
 * 
 *
 */

#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float  *x;                 /* input image  */
  int     size;              /* row , col dim */
  int     k;
  float   min,med,max;
  float   mean,sigma;
  float   Sigmas;
  double  Thresh;
  double  deviation;
 
  if (argc !=  5) {
    printf("\n\n%s: hard clip image values too far off mean.",argv[0]);
    printf("\nusage: %s size infile sigmas outfile\n",argv[0]);
    return;
  }
  size = atoi(argv[1]);
  Sigmas = atoi(argv[3]);
  x = (float *) malloc(size*size*sizeof(float));
  disk2f(x,size,size,argv[2]);

  fsstat(x,size,size,&min,&med,&max,&mean,&sigma);

  Thresh = (double)Sigmas * (double)sigma;

  for (k=0; k < size*size; k++) {
    deviation = fabs((double)(x[k] - mean)); 
    if (deviation > Thresh) {
      x[k] = mean + (float)Thresh;
    } 
  }

  f2disk(x,size,size,argv[4]);
  return;
} 
