
/*
 * fSubMeanAbs.c
 *
 *  read a square floating point image, subtract the mean, take the absolute
 *  value, write as float.
 *
 *  7/17/2001
 *
 */

#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float      *x;                  /* input image  */
  float      *y;                  /* output image  */
  int         size;               /* row , col dim */
  int         i;
  float       min;
  float       med;
  float       max;
  float       mean;
  float       sigma;
  

  if (argc !=  4) {
    printf("\n\n%s: subtract mean and take abs val for float image.",argv[0]);
    printf("\nusage: %s size infile outfile \n",argv[0]);
    return;
  }
  size = atoi(argv[1]);
  x = (float *) malloc(size*size*sizeof(float));
  y = (float *) malloc(size*size*sizeof(float));
 
  disk2f(x,size,size,argv[2]);
  fsstat(x,size,size,&min,&med,&max,&mean,&sigma);

  for (i=0; i< size*size; i++) {
    y[i] = (float)abs((double)(x[i] - mean));
  }

  f2disk(y,size,size,argv[3]);


  return;
} 
