/*
 * fUV2R.c 
 *
 *   read float images for horiz & vert components of instantaneous frequency.
 *   output float image of frequency vector magnitude in radians.
 *
 *
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  float *U;              /* horizontal component of frequency vector */
  float *V;              /* vertical   component of frequency vector */
  float *R;              /* magnitude of frequency vector */
  int    size;           /* row , col dim */
  int    i;              /* loop counter */

  if (argc != 5) {
    printf("\n\n%s: convert cartesian freq vector to radian magnitudes.",
           argv[0]);
    printf("\nusage: %s size Ufile Vfile outfile \n",argv[0]);
    exit(0);
  }

  size = atoi(argv[1]);
  U = (float*) malloc(size*size*sizeof(float));
  V = (float*) malloc(size*size*sizeof(float));
  R  = (float*) malloc(size*size*sizeof(float));
  disk2f(U,size,size,argv[2]);
  disk2f(V,size,size,argv[3]);
  for (i=0; i < size*size; i++) {
    R[i] = (float) pow((double)2.0*(double)M_PI*(double)V[i]
                      *(double)2.0*(double)M_PI*(double)V[i]
                      +(double)2.0*(double)M_PI*(double)U[i]
                      *(double)2.0*(double)M_PI*(double)U[i],(double)0.5);
  }
  f2disk(R,size,size,argv[4]);

  return;
}
