/*
 * fUV2orient.c 
 *
 *   read float images for horiz & vert components of instantaneous frequency.
 *   output float image of frequency vector orientation in radians.
 *
 *
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  float *U;              /* horizontal component of frequency vector */
  float *V;              /* vertical   component of frequency vector */
  float *Theta;          /* orientation of frequency vector */
  int    size;           /* row , col dim */
  int    i;              /* loop counter */

  if (argc != 5) {
    printf("\n\n%s: convert cartesian freq vector to radian orientation.",
           argv[0]);
    printf("\nusage: %s size Ufile Vfile outfile \n",argv[0]);
    exit(0);
  }

  size = atoi(argv[1]);
  U = (float*) malloc(size*size*sizeof(float));
  V = (float*) malloc(size*size*sizeof(float));
  Theta  = (float*) malloc(size*size*sizeof(float));
  disk2f(U,size,size,argv[2]);
  disk2f(V,size,size,argv[3]);
  for (i=0; i < size*size; i++) {
    if ((U[i] == (float)0.0) && (V[i] == (float)0.0)) {
      Theta[i] = (float)0.0;
    } else {
      Theta[i] = (float)atan2((double)V[i],(double)U[i]);
    }
  }
  f2disk(Theta,size,size,argv[4]);

  return;
}
