/*
 * faddquad.c 
 *
 *   Add two float images in quadrature:
 *
 *         y[i] = sqrt(a[i]^2 + b[i]^2)
 *
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  float * x0;            /* 1st component */
  float * x1;            /* 2nd component */
  float * y;             /* quadrature sum image */
  int     size;          /* row , col dim */
  int     i;             /* loop counter */

  if (argc != 5) {
    printf("\n\n%s: add two float images in quadrature.",argv[0]);
    printf("\nusage: %s size infile1 infile2 outfile \n",argv[0]);
    exit(0);
  }

  size = atoi(argv[1]);
  x0 = (float*) malloc(size*size*sizeof(float));
  x1 = (float*) malloc(size*size*sizeof(float));
  y  = (float*) malloc(size*size*sizeof(float));
  disk2f(x0,size,size,argv[2]);
  disk2f(x1,size,size,argv[3]);
  for (i=0; i < size*size; i++) {
    y[i] = (float)pow((double)(x0[i]*x0[i] + x1[i]*x1[i]), (double)0.5);
  }
  f2disk(y,size,size,argv[4]);

  return;
}
