/*
 * fcrop.c 
 *
 *    program reads a float image, and 
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  float * x;            /* image to be read */
  int fd;               /* file descriptor */
  int size;             /* row , col dim */
  int Nrows0;           /* num rows to zero at top and bottom */
  int Ncols0;           /* num cols to zero at top and bottom */
  int row, col;         /* loop counters */
  int i;                /* array index */

  if (argc != 6) {
    printf("\n%s: zero borders of a float image \n",argv[0]);
    printf("\nusage: %s size Nrows0 Ncols0 infile outfile \n",argv[0]);
    exit(0);
  }

  size = atoi(argv[1]);
  Nrows0 = atoi(argv[2]);
  Ncols0 = atoi(argv[3]);
  x = (float*) malloc(size*size*sizeof(float));
  disk2f(x,size,size,argv[4]);

  if ((Nrows0 < 0) || (Ncols0 < 0)) {
    printf("\n%s: Nrows0 & Ncols0 must be > 0.\n",argv[0]);
    exit(-1);
  }
  if (Nrows0<<1 > size) {
    printf("\n%s: Nrows0 must be <= half the image size.\n",argv[0]);
    exit(-1);
  }
  if (Ncols0<<1 > size) {
    printf("\n%s: Ncols0 must be <= half the image size.\n",argv[0]);
    exit(-1);
  }

  for (row=0; row < Nrows0; row++) {
    for (col=0; col < size; col++) {
      x[row*size + col] = x[(size-row-1)*size + col] = (float)0.0;
    }
  }
  for ( ; row < size-Nrows0; row++) {
    for (col=0; col < Ncols0; col++) {
      x[row*size + col] = x[row*size + size - col - 1] = (float)0.0;
    }
  }
  f2disk(x, size, size, argv[5]);

  return;
}
