/*
 * fmaskfuse.c 
 *
 *   Fuse two float images using a BYTE mask image.  Where the mask is zero,
 *   the output image is equal to the first input image.  Where the mask is
 *   255, the output image is equal to the second input image.
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  float * x0;            /* 1st component */
  float * x1;            /* 2nd component */
  float * y;             /* Sum image */
  BYTE  * M;             /* mask image */
  int     size;          /* row , col dim */
  int     i;             /* loop counter */

  if (argc != 6) {
    printf("\n\n%s: fuse two float images using a BYTE mask image.",argv[0]);
    printf("\nusage: %s size infile1 infile2 maskfile outfile \n",argv[0]);
    exit(0);
  }

  size = atoi(argv[1]);
  x0 = (float*) malloc(size*size*sizeof(float));
  x1 = (float*) malloc(size*size*sizeof(float));
  y  = (float*) malloc(size*size*sizeof(float));
  M  = (BYTE*)  malloc(size*size*sizeof(BYTE));

  disk2f(x0,size,size,argv[2]);
  disk2f(x1,size,size,argv[3]);
  disk2byte(M,size,size,argv[4]);

  for (i=0; i < size*size; i++) {
    if (M[i] == 0) {
      y[i] = x0[i];
    } else {
      y[i] = x1[i];
    }
  }
  f2disk(y,size,size,argv[5]);

  return;
}
