/*
 * fmedNxN.c 
 *
 *   do a NxN median filter on a float image
 *
 * 6/19/98 jph
 *
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  float  *x;             /* input */
  float  *y;             /* output image */
  int     size;          /* row/col dimension of image */
  int     WinSize;       /* Num rows/cols in window */

 /*
  * Check for right number of args
  */
  if (argc != 5) {
    printf("\n\n%s: NxN median filter a float image.",argv[0]);
    printf("\nusage: %s size N infile outfile \n",argv[0]);
    exit(0);
  }

 /*
  * Parse args
  */
  size = atoi(argv[1]);
  WinSize = atoi(argv[2]);

 /*
  * Allocate and read input
  */
  x    = (float*) malloc(size*size*sizeof(float));
  disk2f(x,size,size,argv[3]);

 /*
  * Call fmedNxN to do the filtering
  */
  y = fmedNxN(x,size,WinSize,0,0,size-1,size-1);

 /*
  * Write output
  */
  f2disk(y,size,size,argv[4]);

  return;
}
