/*
 * freflect1D.c
 *
 *   read a 1D float sequence from disk, double the length, and fill
 *   the second half with the reflection of the first half to ameliorate
 *   edge effects.
 *
 *   10/10/94 jph
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  int size;
  int TwiceSize;
  int i,j;  
  float * x;
  float * y;

  if (argc != 4) {
    printf("\n\n%s: extend a float sequence by mirroring.",argv[0]);
    printf("\nusage: %s size infile outfile\n",argv[0]);
    return;
  }

  size = atoi(argv[1]);
  TwiceSize = 2 * size;
  printf("\nThe output sequence will be %d points long.\n",TwiceSize);
  x = (float*) malloc(size*sizeof(float));
  disk2f(x,1,size,argv[2]);

  y = (float*) malloc(TwiceSize*sizeof(float));
  for (i=0,j=TwiceSize-1; i < size; i++,j--) {
    y[i] = y[j] = x[i];
  }
  f2disk(y,1,TwiceSize,argv[3]);
  return;
}
