/*
 * fscale1D.c
 *
 * 1D version of fscale.c
 *
 * Scales a float signal with a specified gain.
 *
 */

#ifndef FSCALE1D_C
#define FSCALE1D_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float *x;             /* image to be read */
  float  gain;          /* gain factor */
  float  bias;          /* bias level */
  float *y;             /* output image */
  int    fd;            /* file descriptor */
  int    size;          /* row , col dim */
  int    i;             /* counter */
 
  if (argc !=  6) {
    printf("\n\n%s: scale a float image and add a bias",argv[0]);
    printf("\nusage: %s size infile outfile gain bias\n",argv[0]);
    return;
  }

  size = atoi(argv[1]);
  gain = atof(argv[4]);
  bias = atof(argv[5]);

  x = (float *) malloc(size*size*sizeof(float));
  y = (float *) malloc(size*size*sizeof(float));
  disk2f(x,size,1,argv[2]);
 
  for (i=0; i < size; i++) {
    y[i] = gain * x[i] + bias;
  }
  f2disk(y,size,1,argv[3]);

  return;
} 
#endif
