
/*
 * fsetblock.c
 *
 *  set a block of pixels in a floating point image to a specified value
 *
 */

#ifndef FSETBLOCK_C
#define FSETBLOCK_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float       *x;            /* input image */
  int          fd;           /* file descriptor */
  int          size;         /* row , col dim */
  int          ulx;          /* col of upper left corner of block */
  int          uly;          /* row of upper left corner of block */
  int          lrx;          /* col of lower right corner of block */
  int          lry;          /* row of lower right corner of block */
  float        xx;           /* value for block pixels */
  int          row,col;      /* loop counter */
 
  if (argc !=  9) {
    printf("\n\n%s: set a block of pixels to fvalue in float image.",argv[0]);
    printf("\nusage: %s infile size ulx uly lrx lry fvalue outfile \n",argv[0]);
    return;
  }

  size = atoi(argv[2]);
  ulx   = atoi(argv[3]);
  uly   = atoi(argv[4]);
  lrx   = atoi(argv[5]);
  lry   = atoi(argv[6]);
  xx   = (float)atof(argv[7]);

  x = (float *) malloc(size*size*sizeof(float));
  disk2f(x,size,size,argv[1]);
  
  for (row=uly; row <= lry; row++) {
    for (col=ulx; col <= lrx; col++) {
      x[row*size + col] = xx;
    }
  }
  f2disk(x,size,size,argv[8]);

  return;
} 
#endif
