
/*
 * fshowblock.c
 *
 *  show a block of pixels in a floating point image. Output to StdOut.
 *
 */

#ifndef FSHOWBLOCK_C
#define FSHOWBLOCK_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float       *x;            /* input image */
  int          fd;           /* file descriptor */
  int          size;         /* row , col dim */
  int          ulx;          /* col of upper left corner of block */
  int          uly;          /* row of upper left corner of block */
  int          lrx;          /* col of lower right corner of block */
  int          lry;          /* row of lower right corner of block */
  int          row,col;      /* loop counter */
 
  if (argc !=  7) {
    printf("\n\n%s: show a block of pixels in a float image.",argv[0]);
    printf("\nusage: %s infile size ulx uly lrx lry\n",argv[0]);
    return;
  }

  size = atoi(argv[2]);
  ulx   = atoi(argv[3]);
  uly   = atoi(argv[4]);
  lrx   = atoi(argv[5]);
  lry   = atoi(argv[6]);

  x = (float *) malloc(size*size*sizeof(float));
  disk2f(x,size,size,argv[1]);
  printf("\n\n%s: block upper row=%d; left col=%d",argv[0],ulx,uly);
  for (row=uly; row <= lry; row++) {
    printf("\n");
    for (col=ulx; col <= lrx; col++) {
      printf("% 10.5f",x[row*size + col]);
    }
  }
  printf("\n\n");
  return;
} 
#endif
