
/*
 * fstat1D.c
 *
 * display the statistics of a float sequence
 *
 */

#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float  *x;                 /* input image  */
  int    size;             /* row , col dim */
  float   min,med,max;
  float mean,sigma,sigmasq;
 
  if (argc !=  3) {
    printf("\n\n%s: compute statistics of a float sequence.",argv[0]);
    printf("\nusage: %s size sequencefile \n",argv[0]);
    return;
  }
  size = atoi(argv[1]);
  x = (float *) malloc(size*sizeof(float));
 
  disk2f(x,size,1,argv[2]);
  fsstat(x,size,1,&min,&med,&max,&mean,&sigma);
  sigmasq = sigma * sigma;
  printf("\n\nmax=%f  med=%f  min=%f  mean=%f  stdev=%f  var=%f\n\n",
          max,med,min,mean,sigma,sigmasq);
  return;
} 
