
/*
 * funorm.c
 *
 * Sets mean to zero and extreme magnitude to unity for float image
 *
 */

#ifndef FUNORM_C
#define FUNORM_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{

  float  * x;           /* input  image */
  float  * y;           /* output image */
  int fd;               /* file descriptor */
  int size;             /* row , col dim */
  int N;                /* num pixels in the image */
  int i;                /* loop counter */
  float xsum;           /* sum of x */
  float mean;           /* mean of x */
  float fact;           /* 1 / maxmag */
  float maxmag;         /* max mag value demeaned x */
 
  if (argc !=  4) {
    printf("\n\n%s: set mean to zero and extreme to 1 for float image",argv[0]);
    printf("\nusage: %s size infile outfile \n",argv[0]);
    return;
  }

  size = atoi(argv[1]);
  N = size * size;
  x = (float *) malloc(N*sizeof(float));
  y = (float *) malloc(N*sizeof(float));
  disk2f(x,size,size,argv[2]);
  xsum = (float)0.0;
  for (i=0; i < N; i++) {
    y[i] = x[i];
    xsum += y[i];
  }
  mean = xsum / (float)N;
  maxmag = 0.0;
  for (i=0; i < N; i++) {
    y[i] -= mean;
    if ((float)fabs((double)y[i]) > maxmag) {
      maxmag = (float)fabs((double)y[i]);
    }
  }
  fact = (float)1.0 / maxmag;
  for (i=0; i < N; i++) {
    y[i] *= fact;
  }
  f2disk(y,size,size,argv[3]);

  return;
} 
#endif
