#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define ROUND(x) (int) ((x+0.5)*(1-signbit(x)) + (x - 0.5)*(signbit(x)) )

#ifndef	IMSIZE 
#define IMSIZE 512
#endif	IMSIZE 

main(argc,argv)

int argc;  char *argv[];
{
	float  *x;
	float  e1=64,e2=0,d1=64,d2=0,scale;
	int i,j,k, linesread=0,no_arrows,size=0;
	char  instring[1000];
	unsigned char outim[IMSIZE][IMSIZE];

	if (argc != 2)
	  {
          fprintf(stderr,"Usage: %s outimagefile\n",argv[0]);
	  exit(-1);
	  }
	
	fgets(instring,1000,stdin);
	while (!feof(stdin))
	  {
	  if (strncmp(instring,"#",1) == 0)
	     {
	     if (strncmp(instring,"# Number of arrows",18) == 0)
		{
		sscanf(instring,"%*s %*s %*s %*s %*s %d",&no_arrows);
		printf("\nNO ARROWS=%d",no_arrows);
		x = (float *) malloc(4 * no_arrows * sizeof(float));
	        }
	     if (strncmp(instring,"# SIZE",strlen("# SIZE")) == 0)
		sscanf(instring,"%*s %*s %*s %d",&size);
	     }

	  if (strncmp(instring,"set arrow",strlen("set arrow")) == 0) 
	     {
	     if (no_arrows == 0 || size == 0)
	       {
	       fprintf(stderr,"Bad gnuplot file format: ");
	       fprintf(stderr,"missing SIZE and/or Number of arrows data.\n");
	       exit(-1);
	       }
			       
	     sscanf(instring,"%*s %*s %*s %f,%f %*s %f,%f",
			    &x[linesread*4 + 1],
			    &x[linesread*4 + 0],
			    &x[linesread*4 + 3],
			    &x[linesread*4 + 2]);
	     
	     x[linesread*4 + 0] = size - x[linesread*4 + 0];
	     x[linesread*4 + 2] = size - x[linesread*4 + 2];
	     linesread++;
	     }
	  fgets(instring,1000,stdin);
	  }	

	if (linesread != no_arrows)
	  {
	  fprintf(stderr,"linesread != no_arrows !!\n");
	  fprintf(stderr,"linesread = %d no_arrows = %d\n",linesread,no_arrows);
	  exit(-1);
	  }

	for (i=0; i<no_arrows; i++)
	  {
	  if (x[0+4*i] < e1) e1 = x[0+4*i];  /* find min */
	  if (x[2+4*i] < e1) e1 = x[2+4*i];
	  if (x[0+4*i] > e2) e2 = x[0+4*i]; /* find max */
	  if (x[2+4*i] > e2) e2 = x[2+4*i];

	  if (x[1+4*i] < d1) d1 = x[1+4*i];
	  if (x[3+4*i] < d1) d1 = x[3+4*i];
	  if (x[1+4*i] > d2) d2 = x[1+4*i];
	  if (x[3+4*i] > d2) d2 = x[3+4*i];
	  }

	/* the following fills the entire plot with data */
	/* # means inactivated */
	/*fprintf(stdout,"# %g %g %g %g \n",e1,e2,d1,d2);*/

	/* the following makes the plot from 0->size */
	/* # means inactivated */
	/*fprintf(stdout,"%d %d %d %d \n",0,size,0,size);*/

/*
	fprintf(stdout,"%d\n",no_arrows);
	
	for (i=0; i<no_arrows; i++)
	  {
	  fprintf(stdout,"2\n"); 
	  fprintf(stdout,"%g %g\n",x[0+4*i],x[1+4*i]); 
	  fprintf(stdout,"%g %g\n",x[2+4*i],x[3+4*i]); 
	  }

*/
	scale = (float) IMSIZE / (float) size;

	for (i=0; i<IMSIZE; i++) for (j=0; j<IMSIZE; j++) outim[i][j] = 0;

	for (i=0; i<no_arrows; i++)
	  {
	  line(ROUND( (float) (IMSIZE/size)/2 +scale*x[0+4*i]), 
	       ROUND( (float) (IMSIZE/size)/2 + scale*x[1+4*i]),
	       ROUND( (float) (IMSIZE/size)/2 +scale*x[2+4*i]),
	       ROUND( (float) (IMSIZE/size)/2 +scale*x[3+4*i]),outim);
	  }
	
	write2d(outim,argv[1],IMSIZE);
}


int	signbit(x)

float	x;
{
	if (x < 0) return(1);
	else return(0);
}
