
/*
 * i2b.c
 *
 * converts int image to byte
 *
 */

#ifndef I2B_C
#define I2B_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  int           *x;           /* image to be read */
  double        *xx;          /* double version of x */
  BYTE          *y;           /* output image */
  int            fd;          /* file descriptor */
  int            size;        /* row , col dim */
  int            min, max;    /* min and max of data */
  int            i;           /* loop counter */
  double         fact;        /* normalization factor */
 
  if (argc !=  4) {
    printf("\n\n%s: convert an int image to a byte image",argv[0]);
    printf("\nusage: %s size infile outfile \n",argv[0]);
    return;
  }

  size = atoi(argv[1]);
  x = (int *) malloc(size*size*sizeof(int));
  disk2byte(x,1,size*size*sizeof(int),argv[2]);
  min = max = x[0];
  for (i=1; i<size*size; i++) {
    if (x[i] < min) {
      min = x[i];
    }
    else {
      if (x[i] > max) {
        max = x[i];
      }
    }
  }
  fact = (double)(max - min);
  if (fact == (double)0.0) {
    printf("\n%s: Image has no dynamic range, aborting.\n",argv[0]);
  }
  fact = (double)254 / fact;
  y = (BYTE *) malloc(size * size * sizeof(BYTE));
  for (i=0; i < size*size; i++) {
    y[i] = (BYTE)((double)(x[i] - min) * fact);
  }
  byte2disk(y,size,size,argv[3]);

  return;
} 
#endif
