
/*
 * i2bnoscale.c
 *
 * converts int image to byte without doing any scaling.
 *
 * jph 2/13/99
 */

#ifndef I2BNOSCALE_C
#define I2BNOSCALE_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  int            size;        /* row , col dim */
  char          *infile;      /* input filename */
  char          *outfile;     /* output filename */
  int           *x;           /* input image */
  BYTE          *y;           /* output image */
  int            min, max;    /* min and max of input data */
  int            i;           /* loop counter */
 
  if (argc !=  4) {
    printf("\n\n%s: convert an int image to a byte image without scaling"
                    ,argv[0]);
    printf("\nusage: %s size infile outfile \n",argv[0]);
    return;
  }

 /*
  * Parse args
  */
  size = atoi(argv[1]);
  infile = argv[2];
  outfile = argv[3];

 /*
  * Allocate working arrays
  */
  x = (int *) malloc(size*size*sizeof(int));
  y = (BYTE *) malloc(size * size * sizeof(BYTE));

 /*
  * Read input and find extremes
  */
  disk2byte(x,1,size*size*sizeof(int),infile);
  min = max = x[0];
  for (i=1; i<size*size; i++) {
    if (x[i] < min) {
      min = x[i];
    } else {
      if (x[i] > max) {
        max = x[i];
      }
    }
  }

 /*
  * Check if extremes are in range, abort if not
  */
  if ((min < 0) || (max > 255)) {
    printf("%s has max=%d and min=%d.  Must be in [0,255].\n",infile,min,max);
    exit(1);
  }

 /*
  * Cast input to output and write output file
  */
  for (i=0; i < size*size; i++) {
    y[i] = (BYTE)x[i];
  }
  byte2disk(y,size,size,argv[3]);

  return;
} 
#endif
