/* draws a white (255) line in a IMSIZExIMSIZE byte image.
/* x1,y1,x2,y2   (int) coordinates of endpoints.
/* im            (unsigned char)  image data.
/*
/* Draws a line from (x1,y1) to (x2,y2)
/* Pixels outside the bounds of the image are not turned on.
/* 
/* Keith Bartels 7-24-91
/**/
#include  <stdio.h>
#include <stdlib.h>
#define ONE	255
#define IMSIZE	512
#define INBOUNDS(x) ( ((x)>=0) && ((x)<IMSIZE) )

line(x1,y1,x2,y2,im)
unsigned char im[IMSIZE][IMSIZE];
int	x1,y1,x2,y2;
{
	int	i,j;
	float  dx,dy,m;

	dx = (float) x2 - (float) x1;
	dy = (float) y2 - (float) y1;

	if (x1 == x2)
	  if (y1 == y2)
	    {
	    if ( INBOUNDS(x1) && INBOUNDS(y1) )
	       im[x1][y1] = ONE;
	    }
	  else if (y1<y2)
	    for (j=y1; j<=y2; j++)  
	      {
	      if ( INBOUNDS(x1) && INBOUNDS(j) ) im[x1][j] = ONE;
	      }
	  else if (y2<y1)
	    for (j=y2; j<=y1; j++)  
	      {
	      if ( INBOUNDS(x1) && INBOUNDS(j) ) im[x1][j] = ONE;
	      }

	if ( x1 != x2)
	  {
	  if ( (abs((int) dx) >= abs((int) dy)) || (y1 == y2))
	    {
       	    m = dy/dx;
	    if (x1 < x2)
	      for (i=x1; i<=x2; i++) 
		 {
		 j = y1+ (int) (m* (float)(i-x1));
	         if (INBOUNDS(i) && INBOUNDS(j)) im[i][j] = ONE;
		 }
	    else
	      for (i=x2; i<=x1; i++) 
		 {
		 j = y2 + (int) (m* (float)(i-x2) );
	         if (INBOUNDS(i) && INBOUNDS(j)) im[i][j] = ONE;
		 }
	    }
	  if ((abs((int) dx) < abs((int) dy)) && (y1 != y2))
	    {
	    m=dx/dy;
	    if (y1 < y2)
	      for (j=y1; j<=y2; j++)
		 {
		 i = x1+ (int) (m*(float)(j-y1) );
	         if (INBOUNDS(i) && INBOUNDS(j)) im[i][j] = ONE;
		 }
	    else
	      for (j=y2; j<=y1; j++)
		 {
		 i = x2+ (int) (m*(float)(j-y2) );
	         if (INBOUNDS(i) && INBOUNDS(j)) im[i][j] = ONE;
		 }
	    }
	      
	  }

}	  
