
/*
 * mirror1D.c
 *
 *   reverse time for a 1D signal
 *
 *  jph  10/16/94
 *
 */

#ifndef MIRROR1D_C
#define MIRROR1D_C
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{

  float *x;                /* image to be read */
  float *y;                /* output image */
  int    fd;               /* file descriptor */
  int    size;             /* row , col dim */
  int    i;                /* loop counter */
  int    j;                /* loop counter */
 
 /*
  * If no arguments given, print usage message
  */
  if (argc !=  4) {
    printf("\n\n%s: reverse time for a 1D signal",argv[0]);
    printf("\nusage: %s size infile outfile \n",argv[0]);
    return;
  }

 /*
  * Allocate workspace
  */
  size = atoi(argv[1]);
  x = (float *)malloc(size * sizeof(float));
  y = (float *)malloc(size * sizeof(float));
  
 /*
  * Read signal, time reverse it
  */
  disk2f(x,1,size,argv[2]);
  for (i=0,j=size-1; i < size; i++,j--) {
    y[i]  = x[j];
  }

 /*
  * Write out the time reversed signal
  */
  f2disk(y,1,size,argv[3]);

  return;
} 
#endif
