/*
 * pad800
 *
 * put the 256x256 image in the center of an 800 squared image
 *
 */

#ifndef PAD_800
#define PAD_800
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#define SMALLSIZE 256
#define BIGSIZE 800

main(argc,argv)

  int   argc;
  char *argv[];

{


  unsigned char x[SMALLSIZE][SMALLSIZE];     /* image to be read */
  unsigned char y[BIGSIZE][BIGSIZE];         /* output image */
  int fd;               /* file descriptor */
  int n_bytes;          /* number of bytes to read */
  int start,stop;       /* loop limits */
  int i,j,ii,jj;        /* loop counters */
 
  if (argc !=  3) {
    printf("\n\n%s: put a 256x256 image in the center of an 800x800 image.",argv[0]);
    printf("\n\nusage: pad800 infile outfile \n");
    return;
  }


 /*
  * open the file
  */
  if ((fd = open(argv[1], O_RDONLY))==-1) {
    printf("\n%s : could not open file %s !",argv[0],argv[1]);
    return;
  }

 /*
  * read image data from the file
  */
  n_bytes = SMALLSIZE * SMALLSIZE * sizeof(unsigned char);
  if (read(fd,x,n_bytes) != n_bytes) {
    printf("\npad800.c : complete disk read did not succeed.");
  }

 /*
  * close file 
  */
  if (close(fd) == -1) printf("\npad800.c : error in closing file.");

 /*
  * init y
  */
  for (i=0;i<BIGSIZE;i++)
    for (j=0;j<BIGSIZE;j++) y[i][j] = 0;

 /*
  * fill y
  */
  start = (BIGSIZE-SMALLSIZE) / 2;
  stop  = start + SMALLSIZE;
  for (i=start,ii=0; i<stop; i++,ii++)
    for (j=start,jj=0; j<stop; j++,jj++) y[i][j] = x[ii][jj];

 /*
  * write y
  */
  if ((fd = open(argv[2], O_WRONLY | O_CREAT, 0644))==-1) {
    printf("\npad800.c : could not open file %s!",argv[2]);
    return;
  }

 /*
  * write image data to the file
  */
  n_bytes = BIGSIZE * BIGSIZE;
  if (write(fd,y,n_bytes) != n_bytes) {
    printf("\nwpad800.c : complete disk write did not succeed.");
  }

 /*
  * close file and return
  */
  if (close(fd) == -1) printf("\npad800.c : error in closing file.");
  return;
} 
#endif
