
/*
 * row2image.c
 *
 * read a 1D float signal and create an image with this signal for every row
 *
 */

#ifndef ROW2IMAGE_C
#define ROW2IMAGE_C
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{


  float *x;             /* signal to be converted to image */
  float *y;             /* output image */
  int row,col;          /* loop counters */
  int size;             /* row , col dim */
 
  if (argc !=  4) {
    printf("\n\nusage: %s size infile outfile \n",argv[0]);
    return;
  }
  size = atoi(argv[1]);
  x = (float *) malloc(size*sizeof(float));
  disk2f(x,size,1,argv[2]);

  y = (float *)malloc(size*size*sizeof(float));
  for (row=0; row < size; row++) {
    for (col=0; col < size; col++) {
      y[row*size+col] = x[col];
    }
  }
  f2disk(y,size,size,argv[3]);

  return;
} 
#endif
