/*
 * sqmask.c 
 *
 * make a square mask image.
 *
 */

#include <stdio.h>
#include "teager2D.h"

main(argc,argv)

   int   argc;
  char *argv[];

{

  int   size;       /* size of output image */
  int   sidelen;    /* length of a side of the square */
  float R;          /* radius of a pixel */
  BYTE *y;          /* output image */
  int   so2;        /* size / 2 */
  int   row;        /* image row */
  int   col;        /* image col */
  int   i;          /* cursor */

  if (argc != 4) {
    printf("\n\n%s: make a square mask image.",argv[0]);
    printf("\nusage: %s size sidelen outfile\n");
    exit(-1);
  }

  size = atoi(argv[1]);
  so2 = size >> 1;
  sidelen = atoi(argv[2]);
  y = (BYTE*) malloc(size*size*sizeof(BYTE));

  for (i=0; i < size*size; i++) {
    y[i] = 0;
  }
  for (row = so2 - (sidelen >> 1); row < so2 + (sidelen >> 1); row++) {
    for (col = so2 - (sidelen >> 1); col < so2 + (sidelen >> 1); col++) {
      y[row*size + col] = 255;
    }
  }

  byte2disk(y,size,size,argv[3]);
  return;
}
