
/*
 * subcomps1D.c
 *
 *   reads in two 1D float signals and subtract them.
 *
 *  jph  7/14/98
 *
 */

#ifndef SUBCOMPS1D
#define SUBCOMPS1D
#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include "teager2D.h"

main(argc,argv)

  int   argc;
  char *argv[];

{

  float *x1;              /* image to be read */
  float *x2;              /* image to be read */
  float *y;                /* output image */
  int    fd;               /* file descriptor */
  int    size;             /* row , col dim */
  int    i;                /* loop counter */
  int    k;                /* loop counter */
 
 /*
  * If no arguments given, print usage message
  */
  if (argc !=  5) {
    printf("\n\n%s: subtract 1D float signals.",
           argv[0]);
    printf("\nusage: %s size infile1 infile2 outfile \n",argv[0]);
    return;
  }

 /*
  * Allocate workspace
  */
  size = atoi(argv[1]);
  x1 = (float *)malloc(size * sizeof(float));
  x2 = (float *)malloc(size * sizeof(float));
  y = (float *)malloc(size * sizeof(float));


 /*
  * Read input
  */
  disk2f(x1,1,size,argv[2]);
  disk2f(x2,1,size,argv[3]);

 /*
  * Subtract
  */
  for (i=0; i < size; i++) {
    y[i] = x1[i] - x2[i];
  }

 /*
  * Write out the composite signal
  */
  f2disk(y,1,size,argv[4]);

  return;
} 
#endif
