/*
 * temp2.c
 *
 *   Hack program.
 *
 *  NOTES: sampling interval is unity.
 *         filter center freq is matched to signal.
 * 
 *
 */

#include <stdio.h>
#include <math.h>
#include <fcntl.h>
#include <string.h>

#include "teager2D.h"

/*
 * function prototypes
 */
float GG();
double erf();
double gammp();
void gser();
double gammln();
void gcf();

main(argc,argv) 
 
  int   argc;
  char *argv[];
 
{

  int       i;                 /* loop counter */
  int       j;                 /* used for sign of rand */
  int       row,col;           /* loop counters */
  int       N;                 /* size * size */
  int       size;              /* row/col dim of image */
  int       so2;               /* size/2 */
  float    *psi;               /* inst frequency */
  float     u0;                /* horiz freq. in cycles per pixel */
  float     v0;                /* vert  freq. in cycles per pixel */
  double    phi;               /* magnitude of phase disc. in radians */
  float     SinPhi;            /* sine of phi */
  float     CosPhi;            /* cosine of phi */
  float     sigma;             /* filter space constant */
  float     B;                 /* octave bandwidth of filter */
  float     Eta;               /* Octave BW defined in terms of Eta-peak */
  float     RootGamma;         /* you know what this is */
  double    FourSigmaSquared;  /* 4 * sigma * sigma */
  double    mOneOnFSigSq;      /* - 1 / FourSigmaSquared */
  float     GaussFactor;       /* 1/sqrt(FourSigmaSquared) */
  float     MoreJunk;          /* a Hideous constant */
  float     Gx;                /* Gx */
  float     Gy;                /* Gy */
  char      OutFn[FNSIZE];     /* output filename */

  size   = 512;
  so2 = size >> 1;
  N = size * size;

  if ((psi = (float *)malloc(N * sizeof(float))) == NULL) {
    printf("\n%s: free store exhausted.\n");
    exit(-1);
  }

/*-------------- following are the input variables ------------------------*/
  u0 = (float)0.2;   /* horiz freq = 0.2 cycles/pixel */
  v0 = (float)0.2;   /* vert  freq = 0.2 cycles/pixel */
/*  phi = (float)M_PI_4;*/
  phi = (float)3.0*(float)M_PI/(float)4.0;
  B = (float)1.0;
  Eta = (float)0.5;
  sprintf(OutFn,"WorkDammit.float");
/*-------------------------------------------------------------------------*/

  CosPhi = (float)cos(phi);
  SinPhi = (float)sin(phi);


  RootGamma = (float) (pow((double)2.0,(double)B) - (double)1.0) /
                         (pow((double)2.0,(double)B) + (double)1.0);

  sigma = (float) (M_1_PI * (double)0.5 * 
                    pow((double)-1.0*log((double)Eta),(double)0.5) /
                       (double)(pow((double)(u0*u0 + v0*v0),(double)0.5) 
                    * RootGamma));

  FourSigmaSquared = (double)(sigma * sigma * (float)4.0);

  GaussFactor = (float)pow(FourSigmaSquared * (double)M_PI,(double)-0.5);

  mOneOnFSigSq = (double)-1.0 * pow(FourSigmaSquared,(double)-1.0);

  MoreJunk = (float)2.0*((float)1.0 - CosPhi);

  for (row=-so2,i=0; i < size; i++,row++) {
    for (col=-so2,j=0; j < size; j++,col++) {

      Gx = GG((float)col/(sigma * (float)M_SQRT2));
      Gy = GG((float)row/(sigma * (float)M_SQRT2));

      psi[i*size + j] = u0 + 
          SinPhi / ((float)1.0 - (MoreJunk * Gx * ((float)1.0 - Gx * Gy)))
          * GaussFactor
          * (float)exp((double)(col*col) * mOneOnFSigSq);

    }   /* for col,j */
  }     /* for row,i */ 

  f2disk(psi,size,size,OutFn);

  printf("\n\n");
  exit(0);

} /*----------------------------  main  ------------------------------------*/


/*
 * GG
 *
 *  Return the value of the Gaussian distribution.
 *
 */
float GG(xx)

  float         xx;                  /* argument */
{

  float         rtn;

  rtn = (float)0.5 + (float)0.5 * (float)erf((double)xx / (double)M_SQRT2);
  return(rtn);

} /*--------------------------------  GG  ----------------------------------*/

double erf(x)
double x;
{
        double gammp();

        return x < 0.0 ? -gammp(0.5,x*x) : gammp(0.5,x*x);
} /*--------------------------------  erf  ---------------------------------*/

double gammp(a,x)
double a,x;
{
        double gamser,gammcf,gln;
        void gser(),gcf();

        if (x < 0.0 || a <= 0.0) printf("\nInvalid arguments in routine GAMMP");
        if (x < (a+1.0)) {
                gser(&gamser,a,x,&gln);
                return gamser;
        } else {
                gcf(&gammcf,a,x,&gln);
                return 1.0-gammcf;
        }
} /*--------------------------------  gammp  -------------------------------*/

#define ITMAX 100
#define EPS 3.0e-7

void gser(gamser,a,x,gln)
double a,x,*gamser,*gln;
{
        int n;
        double sum,del,ap;
        double gammln();

        *gln=gammln(a);
        if (x <= 0.0) {
                if (x < 0.0) printf("\nx less than 0 in routine GSER");
                *gamser=0.0;
                return;
        } else {
                ap=a;
                del=sum=1.0/a;
                for (n=1;n<=ITMAX;n++) {
                        ap += 1.0;
                        del *= x/ap;
                        sum += del;
                        if (fabs(del) < fabs(sum)*EPS) {
                                *gamser=sum*exp(-x+a*log(x)-(*gln));
                                return;
                        }
                }
                printf("\na too large, ITMAX too small in routine GSER");
                return;
        }
}

#undef ITMAX
#undef EPS
/*--------------------------------  gser  --------------------------------*/

double gammln(xx)
double xx;
{
        double x,tmp,ser;
        static double cof[6]={76.18009173,-86.50532033,24.01409822,
                -1.231739516,0.120858003e-2,-0.536382e-5};
        int j;

        x=xx-1.0;
        tmp=x+5.5;
        tmp -= (x+0.5)*log(tmp);
        ser=1.0;
        for (j=0;j<=5;j++) {
                x += 1.0;
                ser += cof[j]/x;
        }
        return -tmp+log(2.50662827465*ser);
} /*--------------------------------  gammln  ------------------------------*/

#define ITMAX 100
#define EPS 3.0e-7

void gcf(gammcf,a,x,gln)
double a,x,*gammcf,*gln;
{
        int n;
        double gold=0.0,g,fac=1.0,b1=1.0;
        double b0=0.0,anf,ana,an,a1,a0=1.0;
        double gammln();

        *gln=gammln(a);
        a1=x;
        for (n=1;n<=ITMAX;n++) {
                an=(double) n;
                ana=an-a;
                a0=(a1+a0*ana)*fac;
                b0=(b1+b0*ana)*fac;
                anf=an*fac;
                a1=x*a0+anf*a1;
                b1=x*b0+anf*b1;
                if (a1) {
                        fac=1.0/a1;
                        g=b1*fac;
                        if (fabs((g-gold)/g) < EPS) {
                                *gammcf=exp(-x+a*log(x)-(*gln))*g;
                                return;
                        }
                        gold=g;
                }
        }
        printf("\na=%f too large, ITMAX too small in routine GCF",a);
}

#undef ITMAX
#undef EPS
/*--------------------------------  gcf  ---------------------------------*/







